/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: IExecutionHarnessDataProcessor.java,v 1.6 2005/02/16 22:20:15 qiyanli Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.hyades.execution.harness;

import org.eclipse.hyades.internal.execution.local.common.DataProcessor;
import org.eclipse.hyades.internal.execution.local.control.Agent;
import org.eclipse.hyades.internal.execution.local.control.Process;
import org.eclipse.hyades.models.common.facades.behavioral.ITest;

/**
 * @author Ernest Jessee
 */
public interface IExecutionHarnessDataProcessor extends DataProcessor
{
	/**
	 * @param proc
	 * @param agent
	 */
	public void init();	
	public String getName();
	public String getID();
	public ITest getTest();
	public void setControlAgent(Agent theAgent);
	public Agent getControlAgent();
	/**
	 * Initialize this data processor.
	 * @param theTest
	 * @param hostName
	 * @param executionResultName
	 * @param executionResultLocation
	 * @param portNumber
	 * @deprecated implement {@link IExecutionHarnessDataProcessor2#setInitData(ITest,String,String, boolean, String,String)} instead.
	 */
	public void setInitData(ITest theTest,String hostName,String executionResultName, String executionResultLocation,String portNumber);
	public void setProcess(Process process);
	public Process getProcess();
}
