package org.eclipse.hyades.execution.security;
/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: ISecureServerParameters.java,v 1.4 2005/02/16 22:20:15 qiyanli Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

import java.security.Provider;


/**
 * @author rduggan
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public interface ISecureServerParameters {
		
	public int getPort();
	
	public boolean clientAuthenticationRequired();
	
	public Provider getSecurityProvider();

	public IConnectionHandler getConnectionHandler();
	
	public String getKeystoreFileName();
	
	public String getKeystoreFilepassword();
	
	public IKeystoreManager getKeystoreManager();
	
	public String[] getEnabledCipherSuites();
	
	public String[] getEnabledProtocols();
}
