/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: ExtractorTypeItemProvider.java,v 1.5 2005/02/16 22:20:35 qiyanli Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.extractor.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

import org.eclipse.hyades.logging.adapter.model.internal.extractor.ExtractorPackage;
import org.eclipse.hyades.logging.adapter.model.internal.extractor.ExtractorType;
import org.eclipse.hyades.logging.adapter.ui.AcadEditorPlugin;
import org.eclipse.hyades.logging.adapter.ui.AcadEditorPluginImages;

/**
 * This is the item provider adpater for a {@link org.eclipse.hyades.logging.adapter.model.internal.extractor.ExtractorType} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ExtractorTypeItemProvider
	extends ItemProviderAdapter
	implements
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource {
	public static final String DESCRIPTION = AcadEditorPlugin.getPlugin().getString("STR_EXTR_DESCR");
	public static final String HAS_START_PATTERN = AcadEditorPlugin.getPlugin().getString("STR_EXTR_INC_STARTP");	
	public static final String START_PATTERN = AcadEditorPlugin.getPlugin().getString("STR_EXTR_STARTP");
	public static final String HAS_END_PATTERN = AcadEditorPlugin.getPlugin().getString("STR_EXTR_INC_ENDP");		
	public static final String END_PATTERN = AcadEditorPlugin.getPlugin().getString("STR_EXTR_END_PATTERN");
	public static final String CONTAINS_LINE_BREAKS = AcadEditorPlugin.getPlugin().getString("STR_EXTR_HAS_LINEB");
	public static final String LINE_BREAK_SYMBOL = AcadEditorPlugin.getPlugin().getString("STR_EXTR_LINE_BSYMB");	
	public static final String REPLACE_LINE_BREAKS = AcadEditorPlugin.getPlugin().getString("REPLACE_LINE_BREAK");
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExtractorTypeItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addContainsLineBreaksPropertyDescriptor(object);
			addDescriptionPropertyDescriptor(object);
			addEndPatternPropertyDescriptor(object);
			addIncludeEndPatternPropertyDescriptor(object);
			addIncludeStartPatternPropertyDescriptor(object);
			addLineBreakSymbolPropertyDescriptor(object);
			addReplaceLineBreaksPropertyDescriptor(object);
			addStartPatternPropertyDescriptor(object);
			addUniqueIDPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Contains Line Breaks feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addContainsLineBreaksPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(new ItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getString("STR_EXTR_HAS_LINEB"),
				 getString("_UI_PropertyDescriptor_description", "STR_EXTR_HAS_LINEB", "_UI_ExtractorType_type"),
				 ExtractorPackage.eINSTANCE.getExtractorType_ContainsLineBreaks(),
				 true,
				 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE));
	}

	/**
	 * This adds a property descriptor for the Description feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addDescriptionPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(new ItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getString("STR_EXTR_DESCR"),
				 getString("_UI_PropertyDescriptor_description", "STR_EXTR_DESCR", "_UI_ExtractorType_type"),
				 ExtractorPackage.eINSTANCE.getExtractorType_Description(),
				 true,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE));
	}

	/**
	 * This adds a property descriptor for the End Pattern feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addEndPatternPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(new ItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getString("STR_EXTR_END_PATTERN"),
				 getString("_UI_PropertyDescriptor_description", "STR_EXTR_END_PATTERN", "_UI_ExtractorType_type"),
				 ExtractorPackage.eINSTANCE.getExtractorType_EndPattern(),
				 true,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE));
	}

	/**
	 * This adds a property descriptor for the Include End Pattern feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addIncludeEndPatternPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(new ItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getString("STR_EXTR_INC_ENDP"),
				 getString("_UI_PropertyDescriptor_description", "STR_EXTR_INC_ENDP", "_UI_ExtractorType_type"),
				 ExtractorPackage.eINSTANCE.getExtractorType_IncludeEndPattern(),
				 true,
				 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE));
	}

	/**
	 * This adds a property descriptor for the Include Start Pattern feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addIncludeStartPatternPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(new ItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getString("STR_EXTR_INC_STARTP"),
				 getString("_UI_PropertyDescriptor_description", "STR_EXTR_INC_STARTP", "_UI_ExtractorType_type"),
				 ExtractorPackage.eINSTANCE.getExtractorType_IncludeStartPattern(),
				 true,
				 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE));
	}

	/**
	 * This adds a property descriptor for the Line Break Symbol feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addLineBreakSymbolPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(new ItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getString("STR_EXTR_LINE_BSYMB"),
				 getString("_UI_PropertyDescriptor_description", "STR_EXTR_LINE_BSYMB", "_UI_ExtractorType_type"),
				 ExtractorPackage.eINSTANCE.getExtractorType_LineBreakSymbol(),
				 true,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE));
	}

	/**
	 * This adds a property descriptor for the Replace Line Breaks feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addReplaceLineBreaksPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(new ItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getString("REPLACE_LINE_BREAK"),
				 getString("_UI_PropertyDescriptor_description", "REPLACE_LINE_BREAK", "_UI_ExtractorType_type"),
				 ExtractorPackage.eINSTANCE.getExtractorType_ReplaceLineBreaks(),
				 true,
				 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE));
	}

	/**
	 * This adds a property descriptor for the Start Pattern feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addStartPatternPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(new ItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getString("STR_EXTR_STARTP"),
				 getString("_UI_PropertyDescriptor_description", "STR_EXTR_STARTP", "_UI_ExtractorType_type"),
				 ExtractorPackage.eINSTANCE.getExtractorType_StartPattern(),
				 true,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE));
	}

	/**
	 * This adds a property descriptor for the Unique ID feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addUniqueIDPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(new ItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getString("STR_EXTR_ID"),
				 getString("_UI_PropertyDescriptor_description", "STR_EXTR_ID", "_UI_ExtractorType_type"),
				 ExtractorPackage.eINSTANCE.getExtractorType_UniqueID(),
				 true,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE));
	}


	/**
	 * This returns ExtractorType.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public Object getImage(Object object) {
		return AcadEditorPluginImages.getImage(AcadEditorPluginImages.IMG_UI_EXTRACTOR);
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public String getText(Object object) {
		String label = ((ExtractorType)object).getUniqueID();
		return label == null || label.length() == 0 ?
			getString("_UI_ExtractorType_type") :
			getString("_UI_ExtractorType_type")+" ["  + label + "]";
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(ExtractorType.class)) {
			case ExtractorPackage.EXTRACTOR_TYPE__CONTAINS_LINE_BREAKS:
			case ExtractorPackage.EXTRACTOR_TYPE__DESCRIPTION:
			case ExtractorPackage.EXTRACTOR_TYPE__END_PATTERN:
			case ExtractorPackage.EXTRACTOR_TYPE__INCLUDE_END_PATTERN:
			case ExtractorPackage.EXTRACTOR_TYPE__INCLUDE_START_PATTERN:
			case ExtractorPackage.EXTRACTOR_TYPE__LINE_BREAK_SYMBOL:
			case ExtractorPackage.EXTRACTOR_TYPE__REPLACE_LINE_BREAKS:
			case ExtractorPackage.EXTRACTOR_TYPE__START_PATTERN:
			case ExtractorPackage.EXTRACTOR_TYPE__UNIQUE_ID:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds to the collection of {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing all of the children that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void collectNewChildDescriptors(Collection newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}

	public Object getCreateChildImage(Object owner, Object feature, Object child, Collection selection)
	{
	  return getImage(child);
	}
	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResourceLocator getResourceLocator() {
		return AcadEditorPlugin.INSTANCE;
	}
}
