/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: StringFilterRuleType.java,v 1.2 2005/03/24 21:12:26 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.filter;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>String Filter Rule Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 *     StringFilterRuleType gives a
 *                 definition for a filter rule on a string attribute.
 *                 Rules are defined for a particular attribute which
 *                 has a name and a value.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.filter.StringFilterRuleType#getOperator <em>Operator</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.logging.adapter.model.internal.filter.FilterPackage#getStringFilterRuleType()
 * @model 
 * @generated
 */
public interface StringFilterRuleType extends AbstractFilterRuleType {
	/**
	 * Returns the value of the '<em><b>Operator</b></em>' attribute.
	 * The default value is <code>"equals"</code>.
	 * The literals are from the enumeration {@link org.eclipse.hyades.logging.adapter.model.internal.filter.StringRelationalOperatorType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Operator</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Operator</em>' attribute.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.filter.StringRelationalOperatorType
	 * @see #isSetOperator()
	 * @see #unsetOperator()
	 * @see #setOperator(StringRelationalOperatorType)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.filter.FilterPackage#getStringFilterRuleType_Operator()
	 * @model default="equals" unique="false" unsettable="true" required="true"
	 * @generated
	 */
	StringRelationalOperatorType getOperator();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.filter.StringFilterRuleType#getOperator <em>Operator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Operator</em>' attribute.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.filter.StringRelationalOperatorType
	 * @see #isSetOperator()
	 * @see #unsetOperator()
	 * @see #getOperator()
	 * @generated
	 */
	void setOperator(StringRelationalOperatorType value);

	/**
	 * Unsets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.filter.StringFilterRuleType#getOperator <em>Operator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetOperator()
	 * @see #getOperator()
	 * @see #setOperator(StringRelationalOperatorType)
	 * @generated
	 */
	void unsetOperator();

	/**
	 * Returns whether the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.filter.StringFilterRuleType#getOperator <em>Operator</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Operator</em>' attribute is set.
	 * @see #unsetOperator()
	 * @see #getOperator()
	 * @see #setOperator(StringRelationalOperatorType)
	 * @generated
	 */
	boolean isSetOperator();

} // StringFilterRuleType
