/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: StringRelationalOperatorType.java,v 1.2 2005/03/24 21:12:26 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.filter;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>String Relational Operator Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 *     Relational operators that can operate on
 *                 a string value.
 * <!-- end-model-doc -->
 * @see org.eclipse.hyades.logging.adapter.model.internal.filter.FilterPackage#getStringRelationalOperatorType()
 * @model
 * @generated
 */
public final class StringRelationalOperatorType extends AbstractEnumerator {
	/**
	 * The '<em><b>Equals</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #EQUALS_LITERAL
	 * @model name="equals"
	 * @generated
	 * @ordered
	 */
	public static final int EQUALS = 0;

	/**
	 * The '<em><b>Starts With</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #STARTS_WITH_LITERAL
	 * @model name="startsWith"
	 * @generated
	 * @ordered
	 */
	public static final int STARTS_WITH = 1;

	/**
	 * The '<em><b>Ends With</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #ENDS_WITH_LITERAL
	 * @model name="endsWith"
	 * @generated
	 * @ordered
	 */
	public static final int ENDS_WITH = 2;

	/**
	 * The '<em><b>Contains</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #CONTAINS_LITERAL
	 * @model name="contains"
	 * @generated
	 * @ordered
	 */
	public static final int CONTAINS = 3;

	/**
	 * The '<em><b>Equals</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Equals</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #EQUALS
	 * @generated
	 * @ordered
	 */
	public static final StringRelationalOperatorType EQUALS_LITERAL = new StringRelationalOperatorType(EQUALS, "equals");

	/**
	 * The '<em><b>Starts With</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Starts With</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #STARTS_WITH
	 * @generated
	 * @ordered
	 */
	public static final StringRelationalOperatorType STARTS_WITH_LITERAL = new StringRelationalOperatorType(STARTS_WITH, "startsWith");

	/**
	 * The '<em><b>Ends With</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Ends With</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #ENDS_WITH
	 * @generated
	 * @ordered
	 */
	public static final StringRelationalOperatorType ENDS_WITH_LITERAL = new StringRelationalOperatorType(ENDS_WITH, "endsWith");

	/**
	 * The '<em><b>Contains</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Contains</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #CONTAINS
	 * @generated
	 * @ordered
	 */
	public static final StringRelationalOperatorType CONTAINS_LITERAL = new StringRelationalOperatorType(CONTAINS, "contains");

	/**
	 * An array of all the '<em><b>String Relational Operator Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final StringRelationalOperatorType[] VALUES_ARRAY =
		new StringRelationalOperatorType[] {
			EQUALS_LITERAL,
			STARTS_WITH_LITERAL,
			ENDS_WITH_LITERAL,
			CONTAINS_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>String Relational Operator Type</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>String Relational Operator Type</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static StringRelationalOperatorType get(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			StringRelationalOperatorType result = VALUES_ARRAY[i];
			if (result.toString().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>String Relational Operator Type</b></em>' literal with the specified value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static StringRelationalOperatorType get(int value) {
		switch (value) {
			case EQUALS: return EQUALS_LITERAL;
			case STARTS_WITH: return STARTS_WITH_LITERAL;
			case ENDS_WITH: return ENDS_WITH_LITERAL;
			case CONTAINS: return CONTAINS_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private StringRelationalOperatorType(int value, String name) {
		super(value, name);
	}

} //StringRelationalOperatorType
