/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: FormatterType.java,v 1.9 2005/03/24 21:12:26 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.formatter;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * 
 * 				A formatter has the role of given the input array of
 * 				(name or ID, value string) pairs creating an object that represents
 * 				that data. Usually the data in the array represents a
 * 				complete message or record of some sort.  In each (name or ID, value
 * 				string) pair, the name or ID maps to a member of the object and the
 * 				value string represents the value of that member.
 * 			
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.formatter.FormatterType#getDescription <em>Description</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.formatter.FormatterType#isDummyAttr1 <em>Dummy Attr1</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.formatter.FormatterType#isDummyAttr2 <em>Dummy Attr2</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.formatter.FormatterType#getUniqueID <em>Unique ID</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.logging.adapter.model.internal.formatter.FormatterPackage#getFormatterType()
 * @model 
 * @generated
 */
public interface FormatterType extends EObject{
	/**
	 * Returns the value of the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Description</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Description</em>' attribute.
	 * @see #setDescription(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.formatter.FormatterPackage#getFormatterType_Description()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String"
	 * @generated
	 */
	String getDescription();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.formatter.FormatterType#getDescription <em>Description</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Description</em>' attribute.
	 * @see #getDescription()
	 * @generated
	 */
	void setDescription(String value);

	/**
	 * Returns the value of the '<em><b>Dummy Attr1</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * 
	 * 					Reserved for future use. 
	 * 				
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Dummy Attr1</em>' attribute.
	 * @see #isSetDummyAttr1()
	 * @see #unsetDummyAttr1()
	 * @see #setDummyAttr1(boolean)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.formatter.FormatterPackage#getFormatterType_DummyAttr1()
	 * @model default="false" unique="false" unsettable="true" dataType="org.eclipse.emf.ecore.xml.type.Boolean"
	 * @generated
	 */
	boolean isDummyAttr1();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.formatter.FormatterType#isDummyAttr1 <em>Dummy Attr1</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Dummy Attr1</em>' attribute.
	 * @see #isSetDummyAttr1()
	 * @see #unsetDummyAttr1()
	 * @see #isDummyAttr1()
	 * @generated
	 */
	void setDummyAttr1(boolean value);

	/**
	 * Unsets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.formatter.FormatterType#isDummyAttr1 <em>Dummy Attr1</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetDummyAttr1()
	 * @see #isDummyAttr1()
	 * @see #setDummyAttr1(boolean)
	 * @generated
	 */
	void unsetDummyAttr1();

	/**
	 * Returns whether the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.formatter.FormatterType#isDummyAttr1 <em>Dummy Attr1</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Dummy Attr1</em>' attribute is set.
	 * @see #unsetDummyAttr1()
	 * @see #isDummyAttr1()
	 * @see #setDummyAttr1(boolean)
	 * @generated
	 */
	boolean isSetDummyAttr1();

	/**
	 * Returns the value of the '<em><b>Dummy Attr2</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * 
	 * 					Reserved for future use. 
	 * 				
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Dummy Attr2</em>' attribute.
	 * @see #isSetDummyAttr2()
	 * @see #unsetDummyAttr2()
	 * @see #setDummyAttr2(boolean)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.formatter.FormatterPackage#getFormatterType_DummyAttr2()
	 * @model default="false" unique="false" unsettable="true" dataType="org.eclipse.emf.ecore.xml.type.Boolean"
	 * @generated
	 */
	boolean isDummyAttr2();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.formatter.FormatterType#isDummyAttr2 <em>Dummy Attr2</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Dummy Attr2</em>' attribute.
	 * @see #isSetDummyAttr2()
	 * @see #unsetDummyAttr2()
	 * @see #isDummyAttr2()
	 * @generated
	 */
	void setDummyAttr2(boolean value);

	/**
	 * Unsets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.formatter.FormatterType#isDummyAttr2 <em>Dummy Attr2</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetDummyAttr2()
	 * @see #isDummyAttr2()
	 * @see #setDummyAttr2(boolean)
	 * @generated
	 */
	void unsetDummyAttr2();

	/**
	 * Returns whether the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.formatter.FormatterType#isDummyAttr2 <em>Dummy Attr2</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Dummy Attr2</em>' attribute is set.
	 * @see #unsetDummyAttr2()
	 * @see #isDummyAttr2()
	 * @see #setDummyAttr2(boolean)
	 * @generated
	 */
	boolean isSetDummyAttr2();

	/**
	 * Returns the value of the '<em><b>Unique ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Unique ID</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Unique ID</em>' attribute.
	 * @see #setUniqueID(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.formatter.FormatterPackage#getFormatterType_UniqueID()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String" required="true"
	 * @generated
	 */
	String getUniqueID();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.formatter.FormatterType#getUniqueID <em>Unique ID</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Unique ID</em>' attribute.
	 * @see #getUniqueID()
	 * @generated
	 */
	void setUniqueID(String value);

} // FormatterType
