/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: DocumentRoot.java,v 1.6 2005/03/24 21:12:26 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.outputter;

import org.eclipse.emf.common.util.EMap;

import org.eclipse.emf.ecore.EObject;

import org.eclipse.emf.ecore.util.FeatureMap;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Document Root</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getMixed <em>Mixed</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getXMLNSPrefixMap <em>XMLNS Prefix Map</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getXSISchemaLocation <em>XSI Schema Location</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getLoggingAgentOutputterType <em>Logging Agent Outputter Type</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getNotificationOutputterType <em>Notification Outputter Type</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getSingleFileOutputterType <em>Single File Outputter Type</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getStandardOutOutputterType <em>Standard Out Outputter Type</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterPackage#getDocumentRoot()
 * @model 
 * @generated
 */
public interface DocumentRoot extends EObject{
	/**
	 * Returns the value of the '<em><b>Mixed</b></em>' attribute list.
	 * The list contents are of type {@link org.eclipse.emf.ecore.util.FeatureMap.Entry}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Mixed</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Mixed</em>' attribute list.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterPackage#getDocumentRoot_Mixed()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.EFeatureMapEntry" many="true"
	 * @generated
	 */
	FeatureMap getMixed();

	/**
	 * Returns the value of the '<em><b>XMLNS Prefix Map</b></em>' map.
	 * The key is of type {@link java.lang.String},
	 * and the value is of type {@link java.lang.String},
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>XMLNS Prefix Map</em>' map isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>XMLNS Prefix Map</em>' map.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterPackage#getDocumentRoot_XMLNSPrefixMap()
	 * @model mapType="org.eclipse.emf.ecore.EStringToStringMapEntry" keyType="java.lang.String" valueType="java.lang.String" transient="true"
	 * @generated
	 */
	EMap getXMLNSPrefixMap();

	/**
	 * Returns the value of the '<em><b>XSI Schema Location</b></em>' map.
	 * The key is of type {@link java.lang.String},
	 * and the value is of type {@link java.lang.String},
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>XSI Schema Location</em>' map isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>XSI Schema Location</em>' map.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterPackage#getDocumentRoot_XSISchemaLocation()
	 * @model mapType="org.eclipse.emf.ecore.EStringToStringMapEntry" keyType="java.lang.String" valueType="java.lang.String" transient="true"
	 * @generated
	 */
	EMap getXSISchemaLocation();

	/**
	 * Returns the value of the '<em><b>Logging Agent Outputter Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 *      Deprecated since Hyades 1.3.     A
	 *                 logging agent outputter directs data to a given
	 *                 logging agent. 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Logging Agent Outputter Type</em>' containment reference.
	 * @see #setLoggingAgentOutputterType(LoggingAgentOutputterTypeType)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterPackage#getDocumentRoot_LoggingAgentOutputterType()
	 * @model containment="true" resolveProxies="false" transient="true" volatile="true" derived="true"
	 * @generated
	 */
	LoggingAgentOutputterTypeType getLoggingAgentOutputterType();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getLoggingAgentOutputterType <em>Logging Agent Outputter Type</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Logging Agent Outputter Type</em>' containment reference.
	 * @see #getLoggingAgentOutputterType()
	 * @generated
	 */
	void setLoggingAgentOutputterType(LoggingAgentOutputterTypeType value);

	/**
	 * Returns the value of the '<em><b>Notification Outputter Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 *      An outputter which directs data to a
	 *                 Notification Source. 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Notification Outputter Type</em>' containment reference.
	 * @see #setNotificationOutputterType(NotificationOutputterTypeType)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterPackage#getDocumentRoot_NotificationOutputterType()
	 * @model containment="true" resolveProxies="false" transient="true" volatile="true" derived="true"
	 * @generated
	 */
	NotificationOutputterTypeType getNotificationOutputterType();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getNotificationOutputterType <em>Notification Outputter Type</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Notification Outputter Type</em>' containment reference.
	 * @see #getNotificationOutputterType()
	 * @generated
	 */
	void setNotificationOutputterType(NotificationOutputterTypeType value);

	/**
	 * Returns the value of the '<em><b>Single File Outputter Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 *      Deprecated since Hyades 1.3.     A
	 *                 single file outputter directs data to a given file in
	 *                 a given directory.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Single File Outputter Type</em>' containment reference.
	 * @see #setSingleFileOutputterType(SingleFileOutputterTypeType)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterPackage#getDocumentRoot_SingleFileOutputterType()
	 * @model containment="true" resolveProxies="false" transient="true" volatile="true" derived="true"
	 * @generated
	 */
	SingleFileOutputterTypeType getSingleFileOutputterType();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getSingleFileOutputterType <em>Single File Outputter Type</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Single File Outputter Type</em>' containment reference.
	 * @see #getSingleFileOutputterType()
	 * @generated
	 */
	void setSingleFileOutputterType(SingleFileOutputterTypeType value);

	/**
	 * Returns the value of the '<em><b>Standard Out Outputter Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 *      Deprecated since Hyades 1.3.     A
	 *                 simple outputter to direct data to standard out.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Standard Out Outputter Type</em>' containment reference.
	 * @see #setStandardOutOutputterType(StandardOutOutputterTypeType)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.outputter.OutputterPackage#getDocumentRoot_StandardOutOutputterType()
	 * @model containment="true" resolveProxies="false" transient="true" volatile="true" derived="true"
	 * @generated
	 */
	StandardOutOutputterTypeType getStandardOutOutputterType();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.outputter.DocumentRoot#getStandardOutOutputterType <em>Standard Out Outputter Type</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Standard Out Outputter Type</em>' containment reference.
	 * @see #getStandardOutOutputterType()
	 * @generated
	 */
	void setStandardOutOutputterType(StandardOutOutputterTypeType value);

} // DocumentRoot
