/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: RuleElementType.java,v 1.10 2005/03/24 21:12:27 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.parser;

import java.math.BigInteger;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Rule Element Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * 
 * 			RuleElementTypes are meta descriptors for any structured types.
 * 			The structured type must have a name and it contains an optional
 * 			set of attributes. Structured types may be nested under other
 * 			structured types. 
 * 			
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#getRuleElement <em>Rule Element</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#getRuleAttribute <em>Rule Attribute</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#getId <em>Id</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#getIndex <em>Index</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#isIsChildChoice <em>Is Child Choice</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#isIsRequiredByParent <em>Is Required By Parent</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#getName <em>Name</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage#getRuleElementType()
 * @model 
 * @generated
 */
public interface RuleElementType extends EObject{
	/**
	 * Returns the value of the '<em><b>Rule Element</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Rule Element</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Rule Element</em>' containment reference list.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage#getRuleElementType_RuleElement()
	 * @model type="org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType" containment="true" resolveProxies="false"
	 * @generated
	 */
	EList getRuleElement();

	/**
	 * Returns the value of the '<em><b>Rule Attribute</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleAttributeType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Rule Attribute</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Rule Attribute</em>' containment reference list.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage#getRuleElementType_RuleAttribute()
	 * @model type="org.eclipse.hyades.logging.adapter.model.internal.parser.RuleAttributeType" containment="true" resolveProxies="false"
	 * @generated
	 */
	EList getRuleAttribute();

	/**
	 * Returns the value of the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Id</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Id</em>' attribute.
	 * @see #setId(BigInteger)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage#getRuleElementType_Id()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.Integer"
	 * @generated
	 */
	BigInteger getId();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#getId <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Id</em>' attribute.
	 * @see #getId()
	 * @generated
	 */
	void setId(BigInteger value);

	/**
	 * Returns the value of the '<em><b>Index</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Index</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Index</em>' attribute.
	 * @see #setIndex(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage#getRuleElementType_Index()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String"
	 * @generated
	 */
	String getIndex();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#getIndex <em>Index</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Index</em>' attribute.
	 * @see #getIndex()
	 * @generated
	 */
	void setIndex(String value);

	/**
	 * Returns the value of the '<em><b>Is Child Choice</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Is Child Choice</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Is Child Choice</em>' attribute.
	 * @see #isSetIsChildChoice()
	 * @see #unsetIsChildChoice()
	 * @see #setIsChildChoice(boolean)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage#getRuleElementType_IsChildChoice()
	 * @model default="false" unique="false" unsettable="true" dataType="org.eclipse.emf.ecore.xml.type.Boolean"
	 * @generated
	 */
	boolean isIsChildChoice();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#isIsChildChoice <em>Is Child Choice</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Is Child Choice</em>' attribute.
	 * @see #isSetIsChildChoice()
	 * @see #unsetIsChildChoice()
	 * @see #isIsChildChoice()
	 * @generated
	 */
	void setIsChildChoice(boolean value);

	/**
	 * Unsets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#isIsChildChoice <em>Is Child Choice</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetIsChildChoice()
	 * @see #isIsChildChoice()
	 * @see #setIsChildChoice(boolean)
	 * @generated
	 */
	void unsetIsChildChoice();

	/**
	 * Returns whether the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#isIsChildChoice <em>Is Child Choice</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Is Child Choice</em>' attribute is set.
	 * @see #unsetIsChildChoice()
	 * @see #isIsChildChoice()
	 * @see #setIsChildChoice(boolean)
	 * @generated
	 */
	boolean isSetIsChildChoice();

	/**
	 * Returns the value of the '<em><b>Is Required By Parent</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Is Required By Parent</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Is Required By Parent</em>' attribute.
	 * @see #isSetIsRequiredByParent()
	 * @see #unsetIsRequiredByParent()
	 * @see #setIsRequiredByParent(boolean)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage#getRuleElementType_IsRequiredByParent()
	 * @model default="false" unique="false" unsettable="true" dataType="org.eclipse.emf.ecore.xml.type.Boolean"
	 * @generated
	 */
	boolean isIsRequiredByParent();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#isIsRequiredByParent <em>Is Required By Parent</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Is Required By Parent</em>' attribute.
	 * @see #isSetIsRequiredByParent()
	 * @see #unsetIsRequiredByParent()
	 * @see #isIsRequiredByParent()
	 * @generated
	 */
	void setIsRequiredByParent(boolean value);

	/**
	 * Unsets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#isIsRequiredByParent <em>Is Required By Parent</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetIsRequiredByParent()
	 * @see #isIsRequiredByParent()
	 * @see #setIsRequiredByParent(boolean)
	 * @generated
	 */
	void unsetIsRequiredByParent();

	/**
	 * Returns whether the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#isIsRequiredByParent <em>Is Required By Parent</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Is Required By Parent</em>' attribute is set.
	 * @see #unsetIsRequiredByParent()
	 * @see #isIsRequiredByParent()
	 * @see #setIsRequiredByParent(boolean)
	 * @generated
	 */
	boolean isSetIsRequiredByParent();

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage#getRuleElementType_Name()
	 * @model unique="false" dataType="org.eclipse.emf.ecore.xml.type.String" required="true"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

} // RuleElementType
