/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: ParserConfigTypeItemProvider.java,v 1.6 2005/02/16 22:20:35 qiyanli Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.parser.provider;


import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.common.command.Command;
import org.eclipse.emf.common.command.UnexecutableCommand;
import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.command.CommandParameter;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

import org.eclipse.hyades.logging.adapter.model.internal.parser.ParserConfigType;
import org.eclipse.hyades.logging.adapter.model.internal.parser.ParserFactory;
import org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage;
import org.eclipse.hyades.logging.adapter.model.internal.parser.RuleAttributeType;
import org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType;
import org.eclipse.hyades.logging.adapter.ui.AcadEditorPlugin;
import org.eclipse.hyades.logging.adapter.ui.AcadEditorPluginImages;
import org.eclipse.xsd.XSDElementDeclaration;

/**
 * This is the item provider adpater for a {@link org.eclipse.hyades.logging.adapter.model.internal.parser.ParserConfigType} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ParserConfigTypeItemProvider
	extends ItemProviderAdapter
	implements
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource {
			
	public final static String DESCRIPTION = AcadEditorPlugin.getPlugin().getString("STR_PARSER_DESCR");
	public final static String SEPARATOR = AcadEditorPlugin.getPlugin().getString("STR_PARSER_SEPTOKEN");
	public final static String DESIGNATION = AcadEditorPlugin.getPlugin().getString("STR_PARSER_DESTOKEN");
			
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ParserConfigTypeItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addDescriptionPropertyDescriptor(object);
			addDesignationTokenPropertyDescriptor(object);
			addSeparatorTokenPropertyDescriptor(object);
			addUniqueIDPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Description feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addDescriptionPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(new ItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getString("STR_PARSER_DESCR"),
				 getString("_UI_PropertyDescriptor_description", "STR_PARSER_DESCR", "_UI_ParserConfigType_type"),
				 ParserPackage.eINSTANCE.getParserConfigType_Description(),
				 true,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE));
	}

	/**
	 * This adds a property descriptor for the Designation Token feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addDesignationTokenPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(new ItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getString("STR_PARSER_DESTOKEN"),
				 getString("_UI_PropertyDescriptor_description", "STR_PARSER_DESTOKEN", "_UI_ParserConfigType_type"),
				 ParserPackage.eINSTANCE.getParserConfigType_DesignationToken(),
				 true,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE));
	}

	/**
	 * This adds a property descriptor for the Separator Token feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addSeparatorTokenPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(new ItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getString("STR_PARSER_SEPTOKEN"),
				 getString("_UI_PropertyDescriptor_description", "STR_PARSER_SEPTOKEN", "_UI_ParserConfigType_type"),
				 ParserPackage.eINSTANCE.getParserConfigType_SeparatorToken(),
				 true,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE));
	}

	/**
	 * This adds a property descriptor for the Unique ID feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addUniqueIDPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(new ItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getString("STR_PARSER_ID"),
				 getString("_UI_PropertyDescriptor_description", "STR_PARSER_ID", "_UI_ParserConfigType_type"),
				 ParserPackage.eINSTANCE.getParserConfigType_UniqueID(),
				 true,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Collection getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(ParserPackage.eINSTANCE.getParserConfigType_RuleElement());
		}
		return childrenFeatures;
	}


	/**
	 * This returns ParserConfigType.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public Object getImage(Object object) {
		if(object instanceof RuleElementType)
		{
			if(AcadEditorPlugin.INSTANCE.getCBEElements().get(((RuleElementType)object).getName()) == null)
				return AcadEditorPluginImages.getImage(AcadEditorPluginImages.IMG_UI_NESTING);					
			else
				return AcadEditorPluginImages.getImage(AcadEditorPluginImages.IMG_UI_ELEMENT);			
		}
		else if(object instanceof RuleAttributeType)	
			return AcadEditorPluginImages.getImage(AcadEditorPluginImages.IMG_UI_ATTRIBUTE);
		
		return AcadEditorPluginImages.getImage(AcadEditorPluginImages.IMG_UI_PARSER);
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public String getText(Object object) {
		String label = ((ParserConfigType)object).getUniqueID();
		return label == null || label.length() == 0 ?
			getString("_UI_ParserConfigType_type") :
			getString("_UI_ParserConfigType_type") + " [" + label + "]";
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(ParserConfigType.class)) {
			case ParserPackage.PARSER_CONFIG_TYPE__DESCRIPTION:
			case ParserPackage.PARSER_CONFIG_TYPE__DESIGNATION_TOKEN:
			case ParserPackage.PARSER_CONFIG_TYPE__SEPARATOR_TOKEN:
			case ParserPackage.PARSER_CONFIG_TYPE__UNIQUE_ID:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case ParserPackage.PARSER_CONFIG_TYPE__RULE_ELEMENT:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds to the collection of {@link org.eclipse.emf.edit.command.CommandParameter}s
	 * describing all of the children that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void collectNewChildDescriptors(Collection newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		Iterator elems = AcadEditorPlugin.INSTANCE.getCBEElements().values().iterator();
		while(elems.hasNext())
		{
			XSDElementDeclaration elemDecl = (XSDElementDeclaration)elems.next();
		    
			if(elemDecl.getName().equals(AcadEditorPlugin.cbeName))
			{
				RuleElementType element = ParserFactory.eINSTANCE.createRuleElementType();		
				element.setName(elemDecl.getName());
				newChildDescriptors.add
					(createChildParameter
						(ParserPackage.eINSTANCE.getParserConfigType_RuleElement(),
						 element));
						 
				AcadEditorPlugin.INSTANCE.createRequiredAttributes(element, elemDecl.getType());		 

			}			
		}
	}

	public Object getCreateChildImage(Object owner, Object feature, Object child, Collection selection)
	{
	  return getImage(child);
	}
	
	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResourceLocator getResourceLocator() {
		return AcadEditorPlugin.INSTANCE;
	}
	/* (non-Javadoc)
	 * @see org.eclipse.emf.edit.provider.ItemProviderAdapter#factorAddCommand(org.eclipse.emf.edit.domain.EditingDomain, org.eclipse.emf.edit.command.CommandParameter)
	 */
	protected Command factorAddCommand(EditingDomain domain, CommandParameter commandParameter) {
		if(!isValidTarget(commandParameter))
			return UnexecutableCommand.INSTANCE;
		else
			return super.factorAddCommand(domain, commandParameter);
	}

	/**
	 * @param commandParameter
	 * @return
	 */
	protected boolean isValidTarget(CommandParameter commandParameter) {
		if(commandParameter.getCollection()==null)
			return false;
		boolean result = false;
		for (Iterator iter = commandParameter.getList().iterator(); iter.hasNext();) {
			EObject element = (EObject) iter.next();
			if (element instanceof RuleElementType )
			{
				if(!((RuleElementType) element).getName().equals("CommonBaseEvent") || ((ParserConfigType)getTarget()).getRuleElement().size()>0) 
					return false;
				else
					result = true;
			}
			else
				return false;
			
		}
		return result;
	}
}
