/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: CBEPackage.java,v 1.10 2005/05/09 05:05:15 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.cbe;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.hyades.models.hierarchy.HierarchyPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 * The Common Base Event model is used to  describe a basic model for storing "messages" or logs from a product. The Common Base Event is the core structure for holding such messages which are often refered to as events from the products that log tem.
 * <!-- end-model-doc -->
 * @see org.eclipse.hyades.models.cbe.CBEFactory
 * @generated
 */
public interface CBEPackage extends EPackage{
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = "";

	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "cbe";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.eclipse.org/hyades/models/cbe.xmi";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "CBE";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	CBEPackage eINSTANCE = org.eclipse.hyades.models.cbe.impl.CBEPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.cbe.impl.CBEDefaultEventImpl <em>Default Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.cbe.impl.CBEDefaultEventImpl
	 * @see org.eclipse.hyades.models.cbe.impl.CBEPackageImpl#getCBEDefaultEvent()
	 * @generated
	 */
	int CBE_DEFAULT_EVENT = 5;

	/**
	 * The feature id for the '<em><b>Agent</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_DEFAULT_EVENT__AGENT = HierarchyPackage.ABSTRACT_DEFAULT_EVENT__AGENT;

	/**
	 * The feature id for the '<em><b>Analyzed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_DEFAULT_EVENT__ANALYZED = HierarchyPackage.ABSTRACT_DEFAULT_EVENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Extension Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_DEFAULT_EVENT__EXTENSION_NAME = HierarchyPackage.ABSTRACT_DEFAULT_EVENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Symptoms</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_DEFAULT_EVENT__SYMPTOMS = HierarchyPackage.ABSTRACT_DEFAULT_EVENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Extended Properties</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_DEFAULT_EVENT__EXTENDED_PROPERTIES = HierarchyPackage.ABSTRACT_DEFAULT_EVENT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the the '<em>Default Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_DEFAULT_EVENT_FEATURE_COUNT = HierarchyPackage.ABSTRACT_DEFAULT_EVENT_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.cbe.impl.CBECommonBaseEventImpl <em>Common Base Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.cbe.impl.CBECommonBaseEventImpl
	 * @see org.eclipse.hyades.models.cbe.impl.CBEPackageImpl#getCBECommonBaseEvent()
	 * @generated
	 */
	int CBE_COMMON_BASE_EVENT = 0;

	/**
	 * The feature id for the '<em><b>Agent</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMMON_BASE_EVENT__AGENT = CBE_DEFAULT_EVENT__AGENT;

	/**
	 * The feature id for the '<em><b>Analyzed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMMON_BASE_EVENT__ANALYZED = CBE_DEFAULT_EVENT__ANALYZED;

	/**
	 * The feature id for the '<em><b>Extension Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMMON_BASE_EVENT__EXTENSION_NAME = CBE_DEFAULT_EVENT__EXTENSION_NAME;

	/**
	 * The feature id for the '<em><b>Symptoms</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMMON_BASE_EVENT__SYMPTOMS = CBE_DEFAULT_EVENT__SYMPTOMS;

	/**
	 * The feature id for the '<em><b>Extended Properties</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMMON_BASE_EVENT__EXTENDED_PROPERTIES = CBE_DEFAULT_EVENT__EXTENDED_PROPERTIES;

	/**
	 * The feature id for the '<em><b>Local Instance Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMMON_BASE_EVENT__LOCAL_INSTANCE_ID = CBE_DEFAULT_EVENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Global Instance Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMMON_BASE_EVENT__GLOBAL_INSTANCE_ID = CBE_DEFAULT_EVENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Creation Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMMON_BASE_EVENT__CREATION_TIME = CBE_DEFAULT_EVENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Adjusted Creation Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMMON_BASE_EVENT__ADJUSTED_CREATION_TIME = CBE_DEFAULT_EVENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Time Zone</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMMON_BASE_EVENT__TIME_ZONE = CBE_DEFAULT_EVENT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Severity</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMMON_BASE_EVENT__SEVERITY = CBE_DEFAULT_EVENT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Priority</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMMON_BASE_EVENT__PRIORITY = CBE_DEFAULT_EVENT_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Msg</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMMON_BASE_EVENT__MSG = CBE_DEFAULT_EVENT_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Repeat Count</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMMON_BASE_EVENT__REPEAT_COUNT = CBE_DEFAULT_EVENT_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>Elapsed Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMMON_BASE_EVENT__ELAPSED_TIME = CBE_DEFAULT_EVENT_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>Sequence Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMMON_BASE_EVENT__SEQUENCE_NUMBER = CBE_DEFAULT_EVENT_FEATURE_COUNT + 10;

	/**
	 * The feature id for the '<em><b>Version</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMMON_BASE_EVENT__VERSION = CBE_DEFAULT_EVENT_FEATURE_COUNT + 11;

	/**
	 * The feature id for the '<em><b>Other Data</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMMON_BASE_EVENT__OTHER_DATA = CBE_DEFAULT_EVENT_FEATURE_COUNT + 12;

	/**
	 * The feature id for the '<em><b>Context Data Elements</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMMON_BASE_EVENT__CONTEXT_DATA_ELEMENTS = CBE_DEFAULT_EVENT_FEATURE_COUNT + 13;

	/**
	 * The feature id for the '<em><b>Reporter Component Id</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMMON_BASE_EVENT__REPORTER_COMPONENT_ID = CBE_DEFAULT_EVENT_FEATURE_COUNT + 14;

	/**
	 * The feature id for the '<em><b>Source Component Id</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMMON_BASE_EVENT__SOURCE_COMPONENT_ID = CBE_DEFAULT_EVENT_FEATURE_COUNT + 15;

	/**
	 * The feature id for the '<em><b>Msg Data Element</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMMON_BASE_EVENT__MSG_DATA_ELEMENT = CBE_DEFAULT_EVENT_FEATURE_COUNT + 16;

	/**
	 * The feature id for the '<em><b>Situation</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMMON_BASE_EVENT__SITUATION = CBE_DEFAULT_EVENT_FEATURE_COUNT + 17;

	/**
	 * The number of structural features of the the '<em>Common Base Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMMON_BASE_EVENT_FEATURE_COUNT = CBE_DEFAULT_EVENT_FEATURE_COUNT + 18;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.cbe.impl.CBEDefaultElementImpl <em>Default Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.cbe.impl.CBEDefaultElementImpl
	 * @see org.eclipse.hyades.models.cbe.impl.CBEPackageImpl#getCBEDefaultElement()
	 * @generated
	 */
	int CBE_DEFAULT_ELEMENT = 6;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_DEFAULT_ELEMENT__NAME = 0;

	/**
	 * The feature id for the '<em><b>Values</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_DEFAULT_ELEMENT__VALUES = 1;

	/**
	 * The feature id for the '<em><b>Children</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_DEFAULT_ELEMENT__CHILDREN = 2;

	/**
	 * The number of structural features of the the '<em>Default Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_DEFAULT_ELEMENT_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.cbe.impl.CBEExtendedDataElementImpl <em>Extended Data Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.cbe.impl.CBEExtendedDataElementImpl
	 * @see org.eclipse.hyades.models.cbe.impl.CBEPackageImpl#getCBEExtendedDataElement()
	 * @generated
	 */
	int CBE_EXTENDED_DATA_ELEMENT = 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_EXTENDED_DATA_ELEMENT__NAME = CBE_DEFAULT_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Values</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_EXTENDED_DATA_ELEMENT__VALUES = CBE_DEFAULT_ELEMENT__VALUES;

	/**
	 * The feature id for the '<em><b>Children</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_EXTENDED_DATA_ELEMENT__CHILDREN = CBE_DEFAULT_ELEMENT__CHILDREN;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_EXTENDED_DATA_ELEMENT__TYPE = CBE_DEFAULT_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Hex Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_EXTENDED_DATA_ELEMENT__HEX_VALUE = CBE_DEFAULT_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the the '<em>Extended Data Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_EXTENDED_DATA_ELEMENT_FEATURE_COUNT = CBE_DEFAULT_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.cbe.impl.CBEContextDataElementImpl <em>Context Data Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.cbe.impl.CBEContextDataElementImpl
	 * @see org.eclipse.hyades.models.cbe.impl.CBEPackageImpl#getCBEContextDataElement()
	 * @generated
	 */
	int CBE_CONTEXT_DATA_ELEMENT = 2;

	/**
	 * The feature id for the '<em><b>Context Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_CONTEXT_DATA_ELEMENT__CONTEXT_ID = 0;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_CONTEXT_DATA_ELEMENT__TYPE = 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_CONTEXT_DATA_ELEMENT__NAME = 2;

	/**
	 * The feature id for the '<em><b>Context Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_CONTEXT_DATA_ELEMENT__CONTEXT_VALUE = 3;

	/**
	 * The number of structural features of the the '<em>Context Data Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_CONTEXT_DATA_ELEMENT_FEATURE_COUNT = 4;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.cbe.impl.CBEComponentIdentificationImpl <em>Component Identification</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.cbe.impl.CBEComponentIdentificationImpl
	 * @see org.eclipse.hyades.models.cbe.impl.CBEPackageImpl#getCBEComponentIdentification()
	 * @generated
	 */
	int CBE_COMPONENT_IDENTIFICATION = 3;

	/**
	 * The feature id for the '<em><b>Location</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMPONENT_IDENTIFICATION__LOCATION = 0;

	/**
	 * The feature id for the '<em><b>Location Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMPONENT_IDENTIFICATION__LOCATION_TYPE = 1;

	/**
	 * The feature id for the '<em><b>Application</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMPONENT_IDENTIFICATION__APPLICATION = 2;

	/**
	 * The feature id for the '<em><b>Execution Environment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMPONENT_IDENTIFICATION__EXECUTION_ENVIRONMENT = 3;

	/**
	 * The feature id for the '<em><b>Component</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMPONENT_IDENTIFICATION__COMPONENT = 4;

	/**
	 * The feature id for the '<em><b>Sub Component</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMPONENT_IDENTIFICATION__SUB_COMPONENT = 5;

	/**
	 * The feature id for the '<em><b>Component Id Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMPONENT_IDENTIFICATION__COMPONENT_ID_TYPE = 6;

	/**
	 * The feature id for the '<em><b>Instance Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMPONENT_IDENTIFICATION__INSTANCE_ID = 7;

	/**
	 * The feature id for the '<em><b>Process Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMPONENT_IDENTIFICATION__PROCESS_ID = 8;

	/**
	 * The feature id for the '<em><b>Thread Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMPONENT_IDENTIFICATION__THREAD_ID = 9;

	/**
	 * The feature id for the '<em><b>Component Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMPONENT_IDENTIFICATION__COMPONENT_TYPE = 10;

	/**
	 * The number of structural features of the the '<em>Component Identification</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_COMPONENT_IDENTIFICATION_FEATURE_COUNT = 11;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.cbe.impl.CBEMsgDataElementImpl <em>Msg Data Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.cbe.impl.CBEMsgDataElementImpl
	 * @see org.eclipse.hyades.models.cbe.impl.CBEPackageImpl#getCBEMsgDataElement()
	 * @generated
	 */
	int CBE_MSG_DATA_ELEMENT = 4;

	/**
	 * The feature id for the '<em><b>Msg Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_MSG_DATA_ELEMENT__MSG_ID = 0;

	/**
	 * The feature id for the '<em><b>Msg Id Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_MSG_DATA_ELEMENT__MSG_ID_TYPE = 1;

	/**
	 * The feature id for the '<em><b>Msg Catalog Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_MSG_DATA_ELEMENT__MSG_CATALOG_ID = 2;

	/**
	 * The feature id for the '<em><b>Msg Catalog Tokens</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_MSG_DATA_ELEMENT__MSG_CATALOG_TOKENS = 3;

	/**
	 * The feature id for the '<em><b>Msg Catalog</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_MSG_DATA_ELEMENT__MSG_CATALOG = 4;

	/**
	 * The feature id for the '<em><b>Msg Locale</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_MSG_DATA_ELEMENT__MSG_LOCALE = 5;

	/**
	 * The feature id for the '<em><b>Msg Catalog Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_MSG_DATA_ELEMENT__MSG_CATALOG_TYPE = 6;

	/**
	 * The number of structural features of the the '<em>Msg Data Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_MSG_DATA_ELEMENT_FEATURE_COUNT = 7;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.cbe.impl.CBESituationImpl <em>Situation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.cbe.impl.CBESituationImpl
	 * @see org.eclipse.hyades.models.cbe.impl.CBEPackageImpl#getCBESituation()
	 * @generated
	 */
	int CBE_SITUATION = 7;

	/**
	 * The feature id for the '<em><b>Category Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_SITUATION__CATEGORY_NAME = 0;

	/**
	 * The feature id for the '<em><b>Reasoning Scope</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_SITUATION__REASONING_SCOPE = 1;

	/**
	 * The number of structural features of the the '<em>Situation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_SITUATION_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.cbe.impl.CBEStartSituationImpl <em>Start Situation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.cbe.impl.CBEStartSituationImpl
	 * @see org.eclipse.hyades.models.cbe.impl.CBEPackageImpl#getCBEStartSituation()
	 * @generated
	 */
	int CBE_START_SITUATION = 8;

	/**
	 * The feature id for the '<em><b>Category Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_START_SITUATION__CATEGORY_NAME = CBE_SITUATION__CATEGORY_NAME;

	/**
	 * The feature id for the '<em><b>Reasoning Scope</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_START_SITUATION__REASONING_SCOPE = CBE_SITUATION__REASONING_SCOPE;

	/**
	 * The feature id for the '<em><b>Success Disposition</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_START_SITUATION__SUCCESS_DISPOSITION = CBE_SITUATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Situation Qualifier</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_START_SITUATION__SITUATION_QUALIFIER = CBE_SITUATION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the the '<em>Start Situation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_START_SITUATION_FEATURE_COUNT = CBE_SITUATION_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.cbe.impl.CBEConnectSituationImpl <em>Connect Situation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.cbe.impl.CBEConnectSituationImpl
	 * @see org.eclipse.hyades.models.cbe.impl.CBEPackageImpl#getCBEConnectSituation()
	 * @generated
	 */
	int CBE_CONNECT_SITUATION = 9;

	/**
	 * The feature id for the '<em><b>Category Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_CONNECT_SITUATION__CATEGORY_NAME = CBE_SITUATION__CATEGORY_NAME;

	/**
	 * The feature id for the '<em><b>Reasoning Scope</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_CONNECT_SITUATION__REASONING_SCOPE = CBE_SITUATION__REASONING_SCOPE;

	/**
	 * The feature id for the '<em><b>Success Disposition</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_CONNECT_SITUATION__SUCCESS_DISPOSITION = CBE_SITUATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Situation Disposition</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_CONNECT_SITUATION__SITUATION_DISPOSITION = CBE_SITUATION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the the '<em>Connect Situation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_CONNECT_SITUATION_FEATURE_COUNT = CBE_SITUATION_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.cbe.impl.CBEStopSituationImpl <em>Stop Situation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.cbe.impl.CBEStopSituationImpl
	 * @see org.eclipse.hyades.models.cbe.impl.CBEPackageImpl#getCBEStopSituation()
	 * @generated
	 */
	int CBE_STOP_SITUATION = 10;

	/**
	 * The feature id for the '<em><b>Category Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_STOP_SITUATION__CATEGORY_NAME = CBE_SITUATION__CATEGORY_NAME;

	/**
	 * The feature id for the '<em><b>Reasoning Scope</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_STOP_SITUATION__REASONING_SCOPE = CBE_SITUATION__REASONING_SCOPE;

	/**
	 * The feature id for the '<em><b>Success Disposition</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_STOP_SITUATION__SUCCESS_DISPOSITION = CBE_SITUATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Situation Qualifier</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_STOP_SITUATION__SITUATION_QUALIFIER = CBE_SITUATION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the the '<em>Stop Situation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_STOP_SITUATION_FEATURE_COUNT = CBE_SITUATION_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.cbe.impl.CBEReportSituationImpl <em>Report Situation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.cbe.impl.CBEReportSituationImpl
	 * @see org.eclipse.hyades.models.cbe.impl.CBEPackageImpl#getCBEReportSituation()
	 * @generated
	 */
	int CBE_REPORT_SITUATION = 11;

	/**
	 * The feature id for the '<em><b>Category Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_REPORT_SITUATION__CATEGORY_NAME = CBE_SITUATION__CATEGORY_NAME;

	/**
	 * The feature id for the '<em><b>Reasoning Scope</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_REPORT_SITUATION__REASONING_SCOPE = CBE_SITUATION__REASONING_SCOPE;

	/**
	 * The feature id for the '<em><b>Report Category</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_REPORT_SITUATION__REPORT_CATEGORY = CBE_SITUATION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the the '<em>Report Situation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_REPORT_SITUATION_FEATURE_COUNT = CBE_SITUATION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.cbe.impl.CBEFeatureSituationImpl <em>Feature Situation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.cbe.impl.CBEFeatureSituationImpl
	 * @see org.eclipse.hyades.models.cbe.impl.CBEPackageImpl#getCBEFeatureSituation()
	 * @generated
	 */
	int CBE_FEATURE_SITUATION = 12;

	/**
	 * The feature id for the '<em><b>Category Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_FEATURE_SITUATION__CATEGORY_NAME = CBE_SITUATION__CATEGORY_NAME;

	/**
	 * The feature id for the '<em><b>Reasoning Scope</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_FEATURE_SITUATION__REASONING_SCOPE = CBE_SITUATION__REASONING_SCOPE;

	/**
	 * The feature id for the '<em><b>Feature Disposition</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_FEATURE_SITUATION__FEATURE_DISPOSITION = CBE_SITUATION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the the '<em>Feature Situation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_FEATURE_SITUATION_FEATURE_COUNT = CBE_SITUATION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.cbe.impl.CBEConfigureSituationImpl <em>Configure Situation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.cbe.impl.CBEConfigureSituationImpl
	 * @see org.eclipse.hyades.models.cbe.impl.CBEPackageImpl#getCBEConfigureSituation()
	 * @generated
	 */
	int CBE_CONFIGURE_SITUATION = 13;

	/**
	 * The feature id for the '<em><b>Category Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_CONFIGURE_SITUATION__CATEGORY_NAME = CBE_SITUATION__CATEGORY_NAME;

	/**
	 * The feature id for the '<em><b>Reasoning Scope</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_CONFIGURE_SITUATION__REASONING_SCOPE = CBE_SITUATION__REASONING_SCOPE;

	/**
	 * The feature id for the '<em><b>Success Disposition</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_CONFIGURE_SITUATION__SUCCESS_DISPOSITION = CBE_SITUATION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the the '<em>Configure Situation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_CONFIGURE_SITUATION_FEATURE_COUNT = CBE_SITUATION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.cbe.impl.CBEDependencySituationImpl <em>Dependency Situation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.cbe.impl.CBEDependencySituationImpl
	 * @see org.eclipse.hyades.models.cbe.impl.CBEPackageImpl#getCBEDependencySituation()
	 * @generated
	 */
	int CBE_DEPENDENCY_SITUATION = 14;

	/**
	 * The feature id for the '<em><b>Category Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_DEPENDENCY_SITUATION__CATEGORY_NAME = CBE_SITUATION__CATEGORY_NAME;

	/**
	 * The feature id for the '<em><b>Reasoning Scope</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_DEPENDENCY_SITUATION__REASONING_SCOPE = CBE_SITUATION__REASONING_SCOPE;

	/**
	 * The feature id for the '<em><b>Dependency Disposition</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_DEPENDENCY_SITUATION__DEPENDENCY_DISPOSITION = CBE_SITUATION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the the '<em>Dependency Situation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_DEPENDENCY_SITUATION_FEATURE_COUNT = CBE_SITUATION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.cbe.impl.CBECreateSituationImpl <em>Create Situation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.cbe.impl.CBECreateSituationImpl
	 * @see org.eclipse.hyades.models.cbe.impl.CBEPackageImpl#getCBECreateSituation()
	 * @generated
	 */
	int CBE_CREATE_SITUATION = 15;

	/**
	 * The feature id for the '<em><b>Category Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_CREATE_SITUATION__CATEGORY_NAME = CBE_SITUATION__CATEGORY_NAME;

	/**
	 * The feature id for the '<em><b>Reasoning Scope</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_CREATE_SITUATION__REASONING_SCOPE = CBE_SITUATION__REASONING_SCOPE;

	/**
	 * The feature id for the '<em><b>Success Disposition</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_CREATE_SITUATION__SUCCESS_DISPOSITION = CBE_SITUATION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the the '<em>Create Situation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_CREATE_SITUATION_FEATURE_COUNT = CBE_SITUATION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.cbe.impl.CBEDestroySituationImpl <em>Destroy Situation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.cbe.impl.CBEDestroySituationImpl
	 * @see org.eclipse.hyades.models.cbe.impl.CBEPackageImpl#getCBEDestroySituation()
	 * @generated
	 */
	int CBE_DESTROY_SITUATION = 16;

	/**
	 * The feature id for the '<em><b>Category Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_DESTROY_SITUATION__CATEGORY_NAME = CBE_SITUATION__CATEGORY_NAME;

	/**
	 * The feature id for the '<em><b>Reasoning Scope</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_DESTROY_SITUATION__REASONING_SCOPE = CBE_SITUATION__REASONING_SCOPE;

	/**
	 * The feature id for the '<em><b>Success Disposition</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_DESTROY_SITUATION__SUCCESS_DISPOSITION = CBE_SITUATION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the the '<em>Destroy Situation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_DESTROY_SITUATION_FEATURE_COUNT = CBE_SITUATION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.cbe.impl.CBEAvailableSituationImpl <em>Available Situation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.cbe.impl.CBEAvailableSituationImpl
	 * @see org.eclipse.hyades.models.cbe.impl.CBEPackageImpl#getCBEAvailableSituation()
	 * @generated
	 */
	int CBE_AVAILABLE_SITUATION = 17;

	/**
	 * The feature id for the '<em><b>Category Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_AVAILABLE_SITUATION__CATEGORY_NAME = CBE_SITUATION__CATEGORY_NAME;

	/**
	 * The feature id for the '<em><b>Reasoning Scope</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_AVAILABLE_SITUATION__REASONING_SCOPE = CBE_SITUATION__REASONING_SCOPE;

	/**
	 * The feature id for the '<em><b>Operation Disposition</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_AVAILABLE_SITUATION__OPERATION_DISPOSITION = CBE_SITUATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Processing Disposition</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_AVAILABLE_SITUATION__PROCESSING_DISPOSITION = CBE_SITUATION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Availability Disposition</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_AVAILABLE_SITUATION__AVAILABILITY_DISPOSITION = CBE_SITUATION_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the the '<em>Available Situation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_AVAILABLE_SITUATION_FEATURE_COUNT = CBE_SITUATION_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.cbe.impl.CBERequestSituationImpl <em>Request Situation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.cbe.impl.CBERequestSituationImpl
	 * @see org.eclipse.hyades.models.cbe.impl.CBEPackageImpl#getCBERequestSituation()
	 * @generated
	 */
	int CBE_REQUEST_SITUATION = 18;

	/**
	 * The feature id for the '<em><b>Category Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_REQUEST_SITUATION__CATEGORY_NAME = CBE_SITUATION__CATEGORY_NAME;

	/**
	 * The feature id for the '<em><b>Reasoning Scope</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_REQUEST_SITUATION__REASONING_SCOPE = CBE_SITUATION__REASONING_SCOPE;

	/**
	 * The feature id for the '<em><b>Success Disposition</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_REQUEST_SITUATION__SUCCESS_DISPOSITION = CBE_SITUATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Situation Qualifier</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_REQUEST_SITUATION__SITUATION_QUALIFIER = CBE_SITUATION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the the '<em>Request Situation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_REQUEST_SITUATION_FEATURE_COUNT = CBE_SITUATION_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.models.cbe.impl.CBEOtherSituationImpl <em>Other Situation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.models.cbe.impl.CBEOtherSituationImpl
	 * @see org.eclipse.hyades.models.cbe.impl.CBEPackageImpl#getCBEOtherSituation()
	 * @generated
	 */
	int CBE_OTHER_SITUATION = 19;

	/**
	 * The feature id for the '<em><b>Category Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_OTHER_SITUATION__CATEGORY_NAME = CBE_SITUATION__CATEGORY_NAME;

	/**
	 * The feature id for the '<em><b>Reasoning Scope</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_OTHER_SITUATION__REASONING_SCOPE = CBE_SITUATION__REASONING_SCOPE;

	/**
	 * The feature id for the '<em><b>Any Data</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_OTHER_SITUATION__ANY_DATA = CBE_SITUATION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the the '<em>Other Situation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CBE_OTHER_SITUATION_FEATURE_COUNT = CBE_SITUATION_FEATURE_COUNT + 1;


	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.cbe.CBECommonBaseEvent <em>Common Base Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Common Base Event</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBECommonBaseEvent
	 * @generated
	 */
	EClass getCBECommonBaseEvent();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getLocalInstanceId <em>Local Instance Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Local Instance Id</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getLocalInstanceId()
	 * @see #getCBECommonBaseEvent()
	 * @generated
	 */
	EAttribute getCBECommonBaseEvent_LocalInstanceId();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getGlobalInstanceId <em>Global Instance Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Global Instance Id</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getGlobalInstanceId()
	 * @see #getCBECommonBaseEvent()
	 * @generated
	 */
	EAttribute getCBECommonBaseEvent_GlobalInstanceId();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getCreationTime <em>Creation Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Creation Time</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getCreationTime()
	 * @see #getCBECommonBaseEvent()
	 * @generated
	 */
	EAttribute getCBECommonBaseEvent_CreationTime();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getAdjustedCreationTime <em>Adjusted Creation Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Adjusted Creation Time</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getAdjustedCreationTime()
	 * @see #getCBECommonBaseEvent()
	 * @generated
	 */
	EAttribute getCBECommonBaseEvent_AdjustedCreationTime();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getTimeZone <em>Time Zone</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Time Zone</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getTimeZone()
	 * @see #getCBECommonBaseEvent()
	 * @generated
	 */
	EAttribute getCBECommonBaseEvent_TimeZone();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getSeverity <em>Severity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Severity</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getSeverity()
	 * @see #getCBECommonBaseEvent()
	 * @generated
	 */
	EAttribute getCBECommonBaseEvent_Severity();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getPriority <em>Priority</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Priority</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getPriority()
	 * @see #getCBECommonBaseEvent()
	 * @generated
	 */
	EAttribute getCBECommonBaseEvent_Priority();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getMsg <em>Msg</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Msg</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getMsg()
	 * @see #getCBECommonBaseEvent()
	 * @generated
	 */
	EAttribute getCBECommonBaseEvent_Msg();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getRepeatCount <em>Repeat Count</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Repeat Count</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getRepeatCount()
	 * @see #getCBECommonBaseEvent()
	 * @generated
	 */
	EAttribute getCBECommonBaseEvent_RepeatCount();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getElapsedTime <em>Elapsed Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Elapsed Time</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getElapsedTime()
	 * @see #getCBECommonBaseEvent()
	 * @generated
	 */
	EAttribute getCBECommonBaseEvent_ElapsedTime();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getSequenceNumber <em>Sequence Number</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Sequence Number</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getSequenceNumber()
	 * @see #getCBECommonBaseEvent()
	 * @generated
	 */
	EAttribute getCBECommonBaseEvent_SequenceNumber();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getVersion <em>Version</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Version</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getVersion()
	 * @see #getCBECommonBaseEvent()
	 * @generated
	 */
	EAttribute getCBECommonBaseEvent_Version();

	/**
	 * Returns the meta object for the attribute list '{@link org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getOtherData <em>Other Data</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Other Data</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getOtherData()
	 * @see #getCBECommonBaseEvent()
	 * @generated
	 */
	EAttribute getCBECommonBaseEvent_OtherData();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getContextDataElements <em>Context Data Elements</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Context Data Elements</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getContextDataElements()
	 * @see #getCBECommonBaseEvent()
	 * @generated
	 */
	EReference getCBECommonBaseEvent_ContextDataElements();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getReporterComponentId <em>Reporter Component Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Reporter Component Id</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getReporterComponentId()
	 * @see #getCBECommonBaseEvent()
	 * @generated
	 */
	EReference getCBECommonBaseEvent_ReporterComponentId();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getSourceComponentId <em>Source Component Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Source Component Id</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getSourceComponentId()
	 * @see #getCBECommonBaseEvent()
	 * @generated
	 */
	EReference getCBECommonBaseEvent_SourceComponentId();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getMsgDataElement <em>Msg Data Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Msg Data Element</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getMsgDataElement()
	 * @see #getCBECommonBaseEvent()
	 * @generated
	 */
	EReference getCBECommonBaseEvent_MsgDataElement();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getSituation <em>Situation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Situation</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBECommonBaseEvent#getSituation()
	 * @see #getCBECommonBaseEvent()
	 * @generated
	 */
	EReference getCBECommonBaseEvent_Situation();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.cbe.CBEExtendedDataElement <em>Extended Data Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Extended Data Element</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEExtendedDataElement
	 * @generated
	 */
	EClass getCBEExtendedDataElement();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEExtendedDataElement#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEExtendedDataElement#getType()
	 * @see #getCBEExtendedDataElement()
	 * @generated
	 */
	EAttribute getCBEExtendedDataElement_Type();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEExtendedDataElement#getHexValue <em>Hex Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Hex Value</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEExtendedDataElement#getHexValue()
	 * @see #getCBEExtendedDataElement()
	 * @generated
	 */
	EAttribute getCBEExtendedDataElement_HexValue();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.cbe.CBEContextDataElement <em>Context Data Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Context Data Element</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEContextDataElement
	 * @generated
	 */
	EClass getCBEContextDataElement();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEContextDataElement#getContextId <em>Context Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Context Id</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEContextDataElement#getContextId()
	 * @see #getCBEContextDataElement()
	 * @generated
	 */
	EAttribute getCBEContextDataElement_ContextId();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEContextDataElement#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEContextDataElement#getType()
	 * @see #getCBEContextDataElement()
	 * @generated
	 */
	EAttribute getCBEContextDataElement_Type();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEContextDataElement#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEContextDataElement#getName()
	 * @see #getCBEContextDataElement()
	 * @generated
	 */
	EAttribute getCBEContextDataElement_Name();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEContextDataElement#getContextValue <em>Context Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Context Value</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEContextDataElement#getContextValue()
	 * @see #getCBEContextDataElement()
	 * @generated
	 */
	EAttribute getCBEContextDataElement_ContextValue();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification <em>Component Identification</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Component Identification</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEComponentIdentification
	 * @generated
	 */
	EClass getCBEComponentIdentification();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getLocation <em>Location</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Location</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEComponentIdentification#getLocation()
	 * @see #getCBEComponentIdentification()
	 * @generated
	 */
	EAttribute getCBEComponentIdentification_Location();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getLocationType <em>Location Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Location Type</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEComponentIdentification#getLocationType()
	 * @see #getCBEComponentIdentification()
	 * @generated
	 */
	EAttribute getCBEComponentIdentification_LocationType();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getApplication <em>Application</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Application</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEComponentIdentification#getApplication()
	 * @see #getCBEComponentIdentification()
	 * @generated
	 */
	EAttribute getCBEComponentIdentification_Application();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getExecutionEnvironment <em>Execution Environment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Execution Environment</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEComponentIdentification#getExecutionEnvironment()
	 * @see #getCBEComponentIdentification()
	 * @generated
	 */
	EAttribute getCBEComponentIdentification_ExecutionEnvironment();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getComponent <em>Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Component</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEComponentIdentification#getComponent()
	 * @see #getCBEComponentIdentification()
	 * @generated
	 */
	EAttribute getCBEComponentIdentification_Component();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getSubComponent <em>Sub Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Sub Component</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEComponentIdentification#getSubComponent()
	 * @see #getCBEComponentIdentification()
	 * @generated
	 */
	EAttribute getCBEComponentIdentification_SubComponent();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getComponentIdType <em>Component Id Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Component Id Type</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEComponentIdentification#getComponentIdType()
	 * @see #getCBEComponentIdentification()
	 * @generated
	 */
	EAttribute getCBEComponentIdentification_ComponentIdType();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getInstanceId <em>Instance Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Instance Id</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEComponentIdentification#getInstanceId()
	 * @see #getCBEComponentIdentification()
	 * @generated
	 */
	EAttribute getCBEComponentIdentification_InstanceId();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getProcessId <em>Process Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Process Id</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEComponentIdentification#getProcessId()
	 * @see #getCBEComponentIdentification()
	 * @generated
	 */
	EAttribute getCBEComponentIdentification_ProcessId();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getThreadId <em>Thread Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Thread Id</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEComponentIdentification#getThreadId()
	 * @see #getCBEComponentIdentification()
	 * @generated
	 */
	EAttribute getCBEComponentIdentification_ThreadId();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEComponentIdentification#getComponentType <em>Component Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Component Type</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEComponentIdentification#getComponentType()
	 * @see #getCBEComponentIdentification()
	 * @generated
	 */
	EAttribute getCBEComponentIdentification_ComponentType();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.cbe.CBEMsgDataElement <em>Msg Data Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Msg Data Element</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEMsgDataElement
	 * @generated
	 */
	EClass getCBEMsgDataElement();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgId <em>Msg Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Msg Id</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgId()
	 * @see #getCBEMsgDataElement()
	 * @generated
	 */
	EAttribute getCBEMsgDataElement_MsgId();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgIdType <em>Msg Id Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Msg Id Type</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgIdType()
	 * @see #getCBEMsgDataElement()
	 * @generated
	 */
	EAttribute getCBEMsgDataElement_MsgIdType();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgCatalogId <em>Msg Catalog Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Msg Catalog Id</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgCatalogId()
	 * @see #getCBEMsgDataElement()
	 * @generated
	 */
	EAttribute getCBEMsgDataElement_MsgCatalogId();

	/**
	 * Returns the meta object for the attribute list '{@link org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgCatalogTokens <em>Msg Catalog Tokens</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Msg Catalog Tokens</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgCatalogTokens()
	 * @see #getCBEMsgDataElement()
	 * @generated
	 */
	EAttribute getCBEMsgDataElement_MsgCatalogTokens();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgCatalog <em>Msg Catalog</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Msg Catalog</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgCatalog()
	 * @see #getCBEMsgDataElement()
	 * @generated
	 */
	EAttribute getCBEMsgDataElement_MsgCatalog();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgLocale <em>Msg Locale</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Msg Locale</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgLocale()
	 * @see #getCBEMsgDataElement()
	 * @generated
	 */
	EAttribute getCBEMsgDataElement_MsgLocale();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgCatalogType <em>Msg Catalog Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Msg Catalog Type</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEMsgDataElement#getMsgCatalogType()
	 * @see #getCBEMsgDataElement()
	 * @generated
	 */
	EAttribute getCBEMsgDataElement_MsgCatalogType();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.cbe.CBEDefaultEvent <em>Default Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Default Event</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEDefaultEvent
	 * @generated
	 */
	EClass getCBEDefaultEvent();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEDefaultEvent#isAnalyzed <em>Analyzed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Analyzed</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEDefaultEvent#isAnalyzed()
	 * @see #getCBEDefaultEvent()
	 * @generated
	 */
	EAttribute getCBEDefaultEvent_Analyzed();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEDefaultEvent#getExtensionName <em>Extension Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Extension Name</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEDefaultEvent#getExtensionName()
	 * @see #getCBEDefaultEvent()
	 * @generated
	 */
	EAttribute getCBEDefaultEvent_ExtensionName();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.hyades.models.cbe.CBEDefaultEvent#getSymptoms <em>Symptoms</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Symptoms</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEDefaultEvent#getSymptoms()
	 * @see #getCBEDefaultEvent()
	 * @generated
	 */
	EReference getCBEDefaultEvent_Symptoms();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.hyades.models.cbe.CBEDefaultEvent#getExtendedProperties <em>Extended Properties</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Extended Properties</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEDefaultEvent#getExtendedProperties()
	 * @see #getCBEDefaultEvent()
	 * @generated
	 */
	EReference getCBEDefaultEvent_ExtendedProperties();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.cbe.CBEDefaultElement <em>Default Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Default Element</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEDefaultElement
	 * @generated
	 */
	EClass getCBEDefaultElement();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEDefaultElement#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEDefaultElement#getName()
	 * @see #getCBEDefaultElement()
	 * @generated
	 */
	EAttribute getCBEDefaultElement_Name();

	/**
	 * Returns the meta object for the attribute list '{@link org.eclipse.hyades.models.cbe.CBEDefaultElement#getValues <em>Values</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Values</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEDefaultElement#getValues()
	 * @see #getCBEDefaultElement()
	 * @generated
	 */
	EAttribute getCBEDefaultElement_Values();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.hyades.models.cbe.CBEDefaultElement#getChildren <em>Children</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Children</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEDefaultElement#getChildren()
	 * @see #getCBEDefaultElement()
	 * @generated
	 */
	EReference getCBEDefaultElement_Children();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.cbe.CBESituation <em>Situation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Situation</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBESituation
	 * @generated
	 */
	EClass getCBESituation();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBESituation#getCategoryName <em>Category Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Category Name</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBESituation#getCategoryName()
	 * @see #getCBESituation()
	 * @generated
	 */
	EAttribute getCBESituation_CategoryName();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBESituation#getReasoningScope <em>Reasoning Scope</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Reasoning Scope</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBESituation#getReasoningScope()
	 * @see #getCBESituation()
	 * @generated
	 */
	EAttribute getCBESituation_ReasoningScope();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.cbe.CBEStartSituation <em>Start Situation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Start Situation</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEStartSituation
	 * @generated
	 */
	EClass getCBEStartSituation();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEStartSituation#getSuccessDisposition <em>Success Disposition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Success Disposition</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEStartSituation#getSuccessDisposition()
	 * @see #getCBEStartSituation()
	 * @generated
	 */
	EAttribute getCBEStartSituation_SuccessDisposition();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEStartSituation#getSituationQualifier <em>Situation Qualifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Situation Qualifier</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEStartSituation#getSituationQualifier()
	 * @see #getCBEStartSituation()
	 * @generated
	 */
	EAttribute getCBEStartSituation_SituationQualifier();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.cbe.CBEConnectSituation <em>Connect Situation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Connect Situation</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEConnectSituation
	 * @generated
	 */
	EClass getCBEConnectSituation();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEConnectSituation#getSuccessDisposition <em>Success Disposition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Success Disposition</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEConnectSituation#getSuccessDisposition()
	 * @see #getCBEConnectSituation()
	 * @generated
	 */
	EAttribute getCBEConnectSituation_SuccessDisposition();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEConnectSituation#getSituationDisposition <em>Situation Disposition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Situation Disposition</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEConnectSituation#getSituationDisposition()
	 * @see #getCBEConnectSituation()
	 * @generated
	 */
	EAttribute getCBEConnectSituation_SituationDisposition();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.cbe.CBEStopSituation <em>Stop Situation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Stop Situation</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEStopSituation
	 * @generated
	 */
	EClass getCBEStopSituation();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEStopSituation#getSuccessDisposition <em>Success Disposition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Success Disposition</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEStopSituation#getSuccessDisposition()
	 * @see #getCBEStopSituation()
	 * @generated
	 */
	EAttribute getCBEStopSituation_SuccessDisposition();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEStopSituation#getSituationQualifier <em>Situation Qualifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Situation Qualifier</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEStopSituation#getSituationQualifier()
	 * @see #getCBEStopSituation()
	 * @generated
	 */
	EAttribute getCBEStopSituation_SituationQualifier();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.cbe.CBEReportSituation <em>Report Situation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Report Situation</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEReportSituation
	 * @generated
	 */
	EClass getCBEReportSituation();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEReportSituation#getReportCategory <em>Report Category</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Report Category</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEReportSituation#getReportCategory()
	 * @see #getCBEReportSituation()
	 * @generated
	 */
	EAttribute getCBEReportSituation_ReportCategory();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.cbe.CBEFeatureSituation <em>Feature Situation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Feature Situation</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEFeatureSituation
	 * @generated
	 */
	EClass getCBEFeatureSituation();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEFeatureSituation#getFeatureDisposition <em>Feature Disposition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Feature Disposition</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEFeatureSituation#getFeatureDisposition()
	 * @see #getCBEFeatureSituation()
	 * @generated
	 */
	EAttribute getCBEFeatureSituation_FeatureDisposition();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.cbe.CBEConfigureSituation <em>Configure Situation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Configure Situation</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEConfigureSituation
	 * @generated
	 */
	EClass getCBEConfigureSituation();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEConfigureSituation#getSuccessDisposition <em>Success Disposition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Success Disposition</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEConfigureSituation#getSuccessDisposition()
	 * @see #getCBEConfigureSituation()
	 * @generated
	 */
	EAttribute getCBEConfigureSituation_SuccessDisposition();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.cbe.CBEDependencySituation <em>Dependency Situation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Dependency Situation</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEDependencySituation
	 * @generated
	 */
	EClass getCBEDependencySituation();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEDependencySituation#getDependencyDisposition <em>Dependency Disposition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Dependency Disposition</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEDependencySituation#getDependencyDisposition()
	 * @see #getCBEDependencySituation()
	 * @generated
	 */
	EAttribute getCBEDependencySituation_DependencyDisposition();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.cbe.CBECreateSituation <em>Create Situation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Create Situation</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBECreateSituation
	 * @generated
	 */
	EClass getCBECreateSituation();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBECreateSituation#getSuccessDisposition <em>Success Disposition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Success Disposition</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBECreateSituation#getSuccessDisposition()
	 * @see #getCBECreateSituation()
	 * @generated
	 */
	EAttribute getCBECreateSituation_SuccessDisposition();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.cbe.CBEDestroySituation <em>Destroy Situation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Destroy Situation</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEDestroySituation
	 * @generated
	 */
	EClass getCBEDestroySituation();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEDestroySituation#getSuccessDisposition <em>Success Disposition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Success Disposition</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEDestroySituation#getSuccessDisposition()
	 * @see #getCBEDestroySituation()
	 * @generated
	 */
	EAttribute getCBEDestroySituation_SuccessDisposition();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.cbe.CBEAvailableSituation <em>Available Situation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Available Situation</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEAvailableSituation
	 * @generated
	 */
	EClass getCBEAvailableSituation();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEAvailableSituation#getOperationDisposition <em>Operation Disposition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Operation Disposition</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEAvailableSituation#getOperationDisposition()
	 * @see #getCBEAvailableSituation()
	 * @generated
	 */
	EAttribute getCBEAvailableSituation_OperationDisposition();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEAvailableSituation#getProcessingDisposition <em>Processing Disposition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Processing Disposition</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEAvailableSituation#getProcessingDisposition()
	 * @see #getCBEAvailableSituation()
	 * @generated
	 */
	EAttribute getCBEAvailableSituation_ProcessingDisposition();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBEAvailableSituation#getAvailabilityDisposition <em>Availability Disposition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Availability Disposition</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEAvailableSituation#getAvailabilityDisposition()
	 * @see #getCBEAvailableSituation()
	 * @generated
	 */
	EAttribute getCBEAvailableSituation_AvailabilityDisposition();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.cbe.CBERequestSituation <em>Request Situation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Request Situation</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBERequestSituation
	 * @generated
	 */
	EClass getCBERequestSituation();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBERequestSituation#getSuccessDisposition <em>Success Disposition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Success Disposition</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBERequestSituation#getSuccessDisposition()
	 * @see #getCBERequestSituation()
	 * @generated
	 */
	EAttribute getCBERequestSituation_SuccessDisposition();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.models.cbe.CBERequestSituation#getSituationQualifier <em>Situation Qualifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Situation Qualifier</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBERequestSituation#getSituationQualifier()
	 * @see #getCBERequestSituation()
	 * @generated
	 */
	EAttribute getCBERequestSituation_SituationQualifier();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.models.cbe.CBEOtherSituation <em>Other Situation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Other Situation</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEOtherSituation
	 * @generated
	 */
	EClass getCBEOtherSituation();

	/**
	 * Returns the meta object for the attribute list '{@link org.eclipse.hyades.models.cbe.CBEOtherSituation#getAnyData <em>Any Data</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Any Data</em>'.
	 * @see org.eclipse.hyades.models.cbe.CBEOtherSituation#getAnyData()
	 * @see #getCBEOtherSituation()
	 * @generated
	 */
	EAttribute getCBEOtherSituation_AnyData();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	CBEFactory getCBEFactory();

} //CBEPackage
