/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: Common_ConfigurationFactoryImpl.java,v 1.15 2005/03/28 21:51:31 jptoomey Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.common.configuration.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.impl.EFactoryImpl;
import org.eclipse.hyades.models.common.configuration.*;

import org.eclipse.hyades.models.common.configuration.CFGArtifact;
import org.eclipse.hyades.models.common.configuration.CFGArtifactLocationPair;
import org.eclipse.hyades.models.common.configuration.CFGCategorySelectionAmount;
import org.eclipse.hyades.models.common.configuration.CFGCategorySelectionMode;
import org.eclipse.hyades.models.common.configuration.CFGCategorySelectionMultiplicity;
import org.eclipse.hyades.models.common.configuration.CFGComparableProperty;
import org.eclipse.hyades.models.common.configuration.CFGConfigurableObject;
import org.eclipse.hyades.models.common.configuration.CFGInstance;
import org.eclipse.hyades.models.common.configuration.CFGLocation;
import org.eclipse.hyades.models.common.configuration.CFGMachine;
import org.eclipse.hyades.models.common.configuration.CFGMachineConstraint;
import org.eclipse.hyades.models.common.configuration.CFGMachineInstance;
import org.eclipse.hyades.models.common.configuration.CFGOperation;
import org.eclipse.hyades.models.common.configuration.CFGPropertyGroup;
import org.eclipse.hyades.models.common.configuration.CFGPsudoEnumeration;
import org.eclipse.hyades.models.common.configuration.Common_ConfigurationFactory;
import org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage;
import org.eclipse.hyades.models.common.configuration.HyadesBrowserEnumeration;
import org.eclipse.hyades.models.common.configuration.HyadesBrowserTypeCategory;
import org.eclipse.hyades.models.common.configuration.HyadesBrowserVersionCategory;
import org.eclipse.hyades.models.common.configuration.HyadesDatabaseCategory;
import org.eclipse.hyades.models.common.configuration.HyadesDatabaseEnumeration;
import org.eclipse.hyades.models.common.configuration.HyadesDatabaseVersionCategory;
import org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthCategory;
import org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthEnumeration;
import org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightCategory;
import org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration;
import org.eclipse.hyades.models.common.configuration.HyadesDisplayNumberCategory;
import org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthCategory;
import org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthEnumeration;
import org.eclipse.hyades.models.common.configuration.HyadesHostnameCategory;
import org.eclipse.hyades.models.common.configuration.HyadesMajorVersionCategory;
import org.eclipse.hyades.models.common.configuration.HyadesMemorySizeCategory;
import org.eclipse.hyades.models.common.configuration.HyadesMinorVersionCategory;
import org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemCategory;
import org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration;
import org.eclipse.hyades.models.common.configuration.HyadesPasswordCategory;
import org.eclipse.hyades.models.common.configuration.HyadesProcessorNumberCategory;
import org.eclipse.hyades.models.common.configuration.HyadesProcessorSpeedCategory;
import org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeCategory;
import org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration;
import org.eclipse.hyades.models.common.configuration.HyadesServicePackCategory;
import org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration;
import org.eclipse.hyades.models.common.configuration.HyadesUsernameCategory;
import org.eclipse.hyades.models.common.configuration.HyadesWindowsDomainCategory;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class Common_ConfigurationFactoryImpl extends EFactoryImpl implements Common_ConfigurationFactory
{
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "";

	/**
	 * Creates and instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Common_ConfigurationFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case Common_ConfigurationPackage.CFG_LOCATION: return createCFGLocation();
			case Common_ConfigurationPackage.CFG_OPERATION: return createCFGOperation();
			case Common_ConfigurationPackage.CFG_ARTIFACT: return createCFGArtifact();
			case Common_ConfigurationPackage.CFG_INSTANCE: return createCFGInstance();
			case Common_ConfigurationPackage.CFG_COMPARABLE_PROPERTY: return createCFGComparableProperty();
			case Common_ConfigurationPackage.CFG_PROPERTY_GROUP: return createCFGPropertyGroup();
			case Common_ConfigurationPackage.HYADES_OPERATING_SYSTEM_ENUMERATION: return createHyadesOperatingSystemEnumeration();
			case Common_ConfigurationPackage.HYADES_OPERATING_SYSTEM_CATEGORY: return createHyadesOperatingSystemCategory();
			case Common_ConfigurationPackage.HYADES_PROCESSOR_TYPE_CATEGORY: return createHyadesProcessorTypeCategory();
			case Common_ConfigurationPackage.HYADES_MEMORY_SIZE_CATEGORY: return createHyadesMemorySizeCategory();
			case Common_ConfigurationPackage.HYADES_PROCESSOR_SPEED_CATEGORY: return createHyadesProcessorSpeedCategory();
			case Common_ConfigurationPackage.HYADES_PROCESSOR_TYPE_ENUMERATION: return createHyadesProcessorTypeEnumeration();
			case Common_ConfigurationPackage.HYADES_BROWSER_TYPE_CATEGORY: return createHyadesBrowserTypeCategory();
			case Common_ConfigurationPackage.HYADES_BROWSER_VERSION_CATEGORY: return createHyadesBrowserVersionCategory();
			case Common_ConfigurationPackage.HYADES_BROWSER_ENUMERATION: return createHyadesBrowserEnumeration();
			case Common_ConfigurationPackage.HYADES_PROCESSOR_NUMBER_CATEGORY: return createHyadesProcessorNumberCategory();
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_CATEGORY: return createHyadesDisplayColorDepthCategory();
			case Common_ConfigurationPackage.HYADES_DISPLAY_COLOR_DEPTH_ENUMERATION: return createHyadesDisplayColorDepthEnumeration();
			case Common_ConfigurationPackage.HYADES_DISPLAY_HEIGHT_CATEGORY: return createHyadesDisplayHeightCategory();
			case Common_ConfigurationPackage.HYADES_DISPLAY_WIDTH_CATEGORY: return createHyadesDisplayWidthCategory();
			case Common_ConfigurationPackage.HYADES_DISPLAY_HEIGHT_ENUMERATION: return createHyadesDisplayHeightEnumeration();
			case Common_ConfigurationPackage.HYADES_DISPLAY_WIDTH_ENUMERATION: return createHyadesDisplayWidthEnumeration();
			case Common_ConfigurationPackage.HYADES_DISPLAY_NUMBER_CATEGORY: return createHyadesDisplayNumberCategory();
			case Common_ConfigurationPackage.HYADES_DATABASE_CATEGORY: return createHyadesDatabaseCategory();
			case Common_ConfigurationPackage.HYADES_DATABASE_VERSION_CATEGORY: return createHyadesDatabaseVersionCategory();
			case Common_ConfigurationPackage.HYADES_DATABASE_ENUMERATION: return createHyadesDatabaseEnumeration();
			case Common_ConfigurationPackage.CFG_MACHINE_INSTANCE: return createCFGMachineInstance();
			case Common_ConfigurationPackage.CFG_MACHINE_CONSTRAINT: return createCFGMachineConstraint();
			case Common_ConfigurationPackage.CFG_CONFIGURABLE_OBJECT: return createCFGConfigurableObject();
			case Common_ConfigurationPackage.HYADES_HOSTNAME_CATEGORY: return createHyadesHostnameCategory();
			case Common_ConfigurationPackage.HYADES_WINDOWS_DOMAIN_CATEGORY: return createHyadesWindowsDomainCategory();
			case Common_ConfigurationPackage.HYADES_USERNAME_CATEGORY: return createHyadesUsernameCategory();
			case Common_ConfigurationPackage.HYADES_SERVICE_PACK_CATEGORY: return createHyadesServicePackCategory();
			case Common_ConfigurationPackage.HYADES_MAJOR_VERSION_CATEGORY: return createHyadesMajorVersionCategory();
			case Common_ConfigurationPackage.HYADES_MINOR_VERSION_CATEGORY: return createHyadesMinorVersionCategory();
			case Common_ConfigurationPackage.HYADES_SERVICE_PACK_ENUMERATION: return createHyadesServicePackEnumeration();
			case Common_ConfigurationPackage.CFG_ARTIFACT_LOCATION_PAIR: return createCFGArtifactLocationPair();
			case Common_ConfigurationPackage.CFG_MACHINE: return createCFGMachine();
			case Common_ConfigurationPackage.CFG_PSUDO_ENUMERATION: return createCFGPsudoEnumeration();
			case Common_ConfigurationPackage.HYADES_PASSWORD_CATEGORY: return createHyadesPasswordCategory();
			case Common_ConfigurationPackage.HYADES_CLASSPATH_CATEGORY: return createHyadesClasspathCategory();
			case Common_ConfigurationPackage.HYADES_ROOT_DIRECTROY_CATEGORY: return createHyadesRootDirectroyCategory();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case Common_ConfigurationPackage.CFG_CATEGORY_SELECTION_MODE: {
				CFGCategorySelectionMode result = CFGCategorySelectionMode.get(initialValue);
				if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
				return result;
			}
			case Common_ConfigurationPackage.CFG_CATEGORY_SELECTION_AMOUNT: {
				CFGCategorySelectionAmount result = CFGCategorySelectionAmount.get(initialValue);
				if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
				return result;
			}
			case Common_ConfigurationPackage.CFG_CATEGORY_SELECTION_MULTIPLICITY: {
				CFGCategorySelectionMultiplicity result = CFGCategorySelectionMultiplicity.get(initialValue);
				if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
				return result;
			}
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case Common_ConfigurationPackage.CFG_CATEGORY_SELECTION_MODE:
				return instanceValue == null ? null : instanceValue.toString();
			case Common_ConfigurationPackage.CFG_CATEGORY_SELECTION_AMOUNT:
				return instanceValue == null ? null : instanceValue.toString();
			case Common_ConfigurationPackage.CFG_CATEGORY_SELECTION_MULTIPLICITY:
				return instanceValue == null ? null : instanceValue.toString();
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CFGLocation createCFGLocation() {
		CFGLocationImpl cfgLocation = new CFGLocationImpl();
		return cfgLocation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CFGOperation createCFGOperation() {
		CFGOperationImpl cfgOperation = new CFGOperationImpl();
		return cfgOperation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CFGArtifact createCFGArtifact() {
		CFGArtifactImpl cfgArtifact = new CFGArtifactImpl();
		return cfgArtifact;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CFGInstance createCFGInstance() {
		CFGInstanceImpl cfgInstance = new CFGInstanceImpl();
		return cfgInstance;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CFGComparableProperty createCFGComparableProperty() {
		CFGComparablePropertyImpl cfgComparableProperty = new CFGComparablePropertyImpl();
		return cfgComparableProperty;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CFGPropertyGroup createCFGPropertyGroup() {
		CFGPropertyGroupImpl cfgPropertyGroup = new CFGPropertyGroupImpl();
		return cfgPropertyGroup;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesOperatingSystemEnumeration createHyadesOperatingSystemEnumeration() {
		HyadesOperatingSystemEnumerationImpl hyadesOperatingSystemEnumeration = new HyadesOperatingSystemEnumerationImpl();
		return hyadesOperatingSystemEnumeration;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesOperatingSystemCategory createHyadesOperatingSystemCategory() {
		HyadesOperatingSystemCategoryImpl hyadesOperatingSystemCategory = new HyadesOperatingSystemCategoryImpl();
		return hyadesOperatingSystemCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesProcessorTypeCategory createHyadesProcessorTypeCategory() {
		HyadesProcessorTypeCategoryImpl hyadesProcessorTypeCategory = new HyadesProcessorTypeCategoryImpl();
		return hyadesProcessorTypeCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesMemorySizeCategory createHyadesMemorySizeCategory() {
		HyadesMemorySizeCategoryImpl hyadesMemorySizeCategory = new HyadesMemorySizeCategoryImpl();
		return hyadesMemorySizeCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesProcessorSpeedCategory createHyadesProcessorSpeedCategory() {
		HyadesProcessorSpeedCategoryImpl hyadesProcessorSpeedCategory = new HyadesProcessorSpeedCategoryImpl();
		return hyadesProcessorSpeedCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesProcessorTypeEnumeration createHyadesProcessorTypeEnumeration() {
		HyadesProcessorTypeEnumerationImpl hyadesProcessorTypeEnumeration = new HyadesProcessorTypeEnumerationImpl();
		return hyadesProcessorTypeEnumeration;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesBrowserTypeCategory createHyadesBrowserTypeCategory() {
		HyadesBrowserTypeCategoryImpl hyadesBrowserTypeCategory = new HyadesBrowserTypeCategoryImpl();
		return hyadesBrowserTypeCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesBrowserVersionCategory createHyadesBrowserVersionCategory() {
		HyadesBrowserVersionCategoryImpl hyadesBrowserVersionCategory = new HyadesBrowserVersionCategoryImpl();
		return hyadesBrowserVersionCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesBrowserEnumeration createHyadesBrowserEnumeration() {
		HyadesBrowserEnumerationImpl hyadesBrowserEnumeration = new HyadesBrowserEnumerationImpl();
		return hyadesBrowserEnumeration;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesProcessorNumberCategory createHyadesProcessorNumberCategory() {
		HyadesProcessorNumberCategoryImpl hyadesProcessorNumberCategory = new HyadesProcessorNumberCategoryImpl();
		return hyadesProcessorNumberCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesDisplayColorDepthCategory createHyadesDisplayColorDepthCategory() {
		HyadesDisplayColorDepthCategoryImpl hyadesDisplayColorDepthCategory = new HyadesDisplayColorDepthCategoryImpl();
		return hyadesDisplayColorDepthCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesDisplayColorDepthEnumeration createHyadesDisplayColorDepthEnumeration() {
		HyadesDisplayColorDepthEnumerationImpl hyadesDisplayColorDepthEnumeration = new HyadesDisplayColorDepthEnumerationImpl();
		return hyadesDisplayColorDepthEnumeration;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesDisplayHeightCategory createHyadesDisplayHeightCategory() {
		HyadesDisplayHeightCategoryImpl hyadesDisplayHeightCategory = new HyadesDisplayHeightCategoryImpl();
		return hyadesDisplayHeightCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesDisplayWidthCategory createHyadesDisplayWidthCategory() {
		HyadesDisplayWidthCategoryImpl hyadesDisplayWidthCategory = new HyadesDisplayWidthCategoryImpl();
		return hyadesDisplayWidthCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesDisplayHeightEnumeration createHyadesDisplayHeightEnumeration() {
		HyadesDisplayHeightEnumerationImpl hyadesDisplayHeightEnumeration = new HyadesDisplayHeightEnumerationImpl();
		return hyadesDisplayHeightEnumeration;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesDisplayWidthEnumeration createHyadesDisplayWidthEnumeration() {
		HyadesDisplayWidthEnumerationImpl hyadesDisplayWidthEnumeration = new HyadesDisplayWidthEnumerationImpl();
		return hyadesDisplayWidthEnumeration;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesDisplayNumberCategory createHyadesDisplayNumberCategory() {
		HyadesDisplayNumberCategoryImpl hyadesDisplayNumberCategory = new HyadesDisplayNumberCategoryImpl();
		return hyadesDisplayNumberCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesDatabaseCategory createHyadesDatabaseCategory() {
		HyadesDatabaseCategoryImpl hyadesDatabaseCategory = new HyadesDatabaseCategoryImpl();
		return hyadesDatabaseCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesDatabaseVersionCategory createHyadesDatabaseVersionCategory() {
		HyadesDatabaseVersionCategoryImpl hyadesDatabaseVersionCategory = new HyadesDatabaseVersionCategoryImpl();
		return hyadesDatabaseVersionCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesDatabaseEnumeration createHyadesDatabaseEnumeration() {
		HyadesDatabaseEnumerationImpl hyadesDatabaseEnumeration = new HyadesDatabaseEnumerationImpl();
		return hyadesDatabaseEnumeration;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CFGMachineInstance createCFGMachineInstance() {
		CFGMachineInstanceImpl cfgMachineInstance = new CFGMachineInstanceImpl();
		return cfgMachineInstance;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CFGMachineConstraint createCFGMachineConstraint() {
		CFGMachineConstraintImpl cfgMachineConstraint = new CFGMachineConstraintImpl();
		return cfgMachineConstraint;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CFGConfigurableObject createCFGConfigurableObject() {
		CFGConfigurableObjectImpl cfgConfigurableObject = new CFGConfigurableObjectImpl();
		return cfgConfigurableObject;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesHostnameCategory createHyadesHostnameCategory() {
		HyadesHostnameCategoryImpl hyadesHostnameCategory = new HyadesHostnameCategoryImpl();
		return hyadesHostnameCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesWindowsDomainCategory createHyadesWindowsDomainCategory() {
		HyadesWindowsDomainCategoryImpl hyadesWindowsDomainCategory = new HyadesWindowsDomainCategoryImpl();
		return hyadesWindowsDomainCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesUsernameCategory createHyadesUsernameCategory() {
		HyadesUsernameCategoryImpl hyadesUsernameCategory = new HyadesUsernameCategoryImpl();
		return hyadesUsernameCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesServicePackCategory createHyadesServicePackCategory() {
		HyadesServicePackCategoryImpl hyadesServicePackCategory = new HyadesServicePackCategoryImpl();
		return hyadesServicePackCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesMajorVersionCategory createHyadesMajorVersionCategory() {
		HyadesMajorVersionCategoryImpl hyadesMajorVersionCategory = new HyadesMajorVersionCategoryImpl();
		return hyadesMajorVersionCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesMinorVersionCategory createHyadesMinorVersionCategory() {
		HyadesMinorVersionCategoryImpl hyadesMinorVersionCategory = new HyadesMinorVersionCategoryImpl();
		return hyadesMinorVersionCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesServicePackEnumeration createHyadesServicePackEnumeration() {
		HyadesServicePackEnumerationImpl hyadesServicePackEnumeration = new HyadesServicePackEnumerationImpl();
		return hyadesServicePackEnumeration;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CFGArtifactLocationPair createCFGArtifactLocationPair() {
		CFGArtifactLocationPairImpl cfgArtifactLocationPair = new CFGArtifactLocationPairImpl();
		return cfgArtifactLocationPair;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CFGMachine createCFGMachine() {
		CFGMachineImpl cfgMachine = new CFGMachineImpl();
		return cfgMachine;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CFGPsudoEnumeration createCFGPsudoEnumeration() {
		CFGPsudoEnumerationImpl cfgPsudoEnumeration = new CFGPsudoEnumerationImpl();
		return cfgPsudoEnumeration;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesPasswordCategory createHyadesPasswordCategory() {
		HyadesPasswordCategoryImpl hyadesPasswordCategory = new HyadesPasswordCategoryImpl();
		return hyadesPasswordCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesClasspathCategory createHyadesClasspathCategory() {
		HyadesClasspathCategoryImpl hyadesClasspathCategory = new HyadesClasspathCategoryImpl();
		return hyadesClasspathCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HyadesRootDirectroyCategory createHyadesRootDirectroyCategory() {
		HyadesRootDirectroyCategoryImpl hyadesRootDirectroyCategory = new HyadesRootDirectroyCategoryImpl();
		return hyadesRootDirectroyCategory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Common_ConfigurationPackage getCommon_ConfigurationPackage() {
		return (Common_ConfigurationPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	public static Common_ConfigurationPackage getPackage() {
		return Common_ConfigurationPackage.eINSTANCE;
	}

} //Common_ConfigurationFactoryImpl
