/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: BVRInteractionOccurrenceImpl.java,v 1.14 2005/03/28 21:51:32 jptoomey Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.common.fragments.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.hyades.models.common.fragments.BVRGate;
import org.eclipse.hyades.models.common.fragments.BVRInteraction;
import org.eclipse.hyades.models.common.fragments.BVRInteractionOccurrence;
import org.eclipse.hyades.models.common.fragments.Common_Behavior_FragmentsPackage;
import org.eclipse.hyades.models.common.interactions.impl.BVRInteractionFragmentImpl;
import org.eclipse.hyades.models.common.testprofile.TPFDefaultApplication;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>BVR Interaction Occurrence</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.fragments.impl.BVRInteractionOccurrenceImpl#getActualGates <em>Actual Gates</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.fragments.impl.BVRInteractionOccurrenceImpl#getReferredBehavior <em>Referred Behavior</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class BVRInteractionOccurrenceImpl extends BVRInteractionFragmentImpl implements BVRInteractionOccurrence
{
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "";

	/**
	 * The cached value of the '{@link #getActualGates() <em>Actual Gates</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActualGates()
	 * @generated
	 * @ordered
	 */
	protected EList actualGates = null;

	/**
	 * The cached value of the '{@link #getReferredBehavior() <em>Referred Behavior</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReferredBehavior()
	 * @generated
	 * @ordered
	 */
	protected BVRInteraction referredBehavior = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BVRInteractionOccurrenceImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return Common_Behavior_FragmentsPackage.eINSTANCE.getBVRInteractionOccurrence();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getActualGates() {
		if (actualGates == null) {
			actualGates = new EObjectContainmentEList(BVRGate.class, this, Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__ACTUAL_GATES);
		}
		return actualGates;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRInteraction getReferredBehavior() {
		if (referredBehavior != null && referredBehavior.eIsProxy()) {
			BVRInteraction oldReferredBehavior = referredBehavior;
			referredBehavior = (BVRInteraction)eResolveProxy((InternalEObject)referredBehavior);
			if (referredBehavior != oldReferredBehavior) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__REFERRED_BEHAVIOR, oldReferredBehavior, referredBehavior));
			}
		}
		return referredBehavior;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRInteraction basicGetReferredBehavior() {
		return referredBehavior;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setReferredBehavior(BVRInteraction newReferredBehavior) {
		BVRInteraction oldReferredBehavior = referredBehavior;
		referredBehavior = newReferredBehavior;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__REFERRED_BEHAVIOR, oldReferredBehavior, referredBehavior));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__LIFELINES:
					return ((InternalEList)getLifelines()).basicAdd(otherEnd, msgs);
				case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__MESSAGES:
					return ((InternalEList)getMessages()).basicAdd(otherEnd, msgs);
				case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__INTERACTION:
					if (eContainer != null)
						msgs = eBasicRemoveFromContainer(msgs);
					return eBasicSetContainer(otherEnd, Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__INTERACTION, msgs);
				case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__DEFAULT_APPLICATION:
					if (defaultApplication != null)
						msgs = ((InternalEObject)defaultApplication).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__DEFAULT_APPLICATION, null, msgs);
					return basicSetDefaultApplication((TPFDefaultApplication)otherEnd, msgs);
				default:
					return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__LIFELINES:
					return ((InternalEList)getLifelines()).basicRemove(otherEnd, msgs);
				case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__GENERAL_ORDERINGS:
					return ((InternalEList)getGeneralOrderings()).basicRemove(otherEnd, msgs);
				case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__MESSAGES:
					return ((InternalEList)getMessages()).basicRemove(otherEnd, msgs);
				case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__ANNOTATIONS:
					return ((InternalEList)getAnnotations()).basicRemove(otherEnd, msgs);
				case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__INTERACTION:
					return eBasicSetContainer(null, Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__INTERACTION, msgs);
				case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__PROPERTIES:
					return ((InternalEList)getProperties()).basicRemove(otherEnd, msgs);
				case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__DEFAULT_APPLICATION:
					return basicSetDefaultApplication(null, msgs);
				case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__ACTUAL_GATES:
					return ((InternalEList)getActualGates()).basicRemove(otherEnd, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
				case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__INTERACTION:
					return ((InternalEObject)eContainer).eInverseRemove(this, Common_Behavior_FragmentsPackage.BVR_INTERACTION__INTERACTION_FRAGMENTS, BVRInteraction.class, msgs);
				default:
					return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return ((InternalEObject)eContainer).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__ID:
				return getId();
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__DESCRIPTION:
				return getDescription();
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__NAME:
				return getName();
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__LIFELINES:
				return getLifelines();
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__GENERAL_ORDERINGS:
				return getGeneralOrderings();
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__MESSAGES:
				return getMessages();
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__ANNOTATIONS:
				return getAnnotations();
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__INTERACTION:
				return getInteraction();
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__PROPERTIES:
				return getProperties();
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__DEFAULT_APPLICATION:
				return getDefaultApplication();
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__ACTUAL_GATES:
				return getActualGates();
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__REFERRED_BEHAVIOR:
				if (resolve) return getReferredBehavior();
				return basicGetReferredBehavior();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__ID:
				setId((String)newValue);
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__DESCRIPTION:
				setDescription((String)newValue);
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__NAME:
				setName((String)newValue);
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__LIFELINES:
				getLifelines().clear();
				getLifelines().addAll((Collection)newValue);
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__GENERAL_ORDERINGS:
				getGeneralOrderings().clear();
				getGeneralOrderings().addAll((Collection)newValue);
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__MESSAGES:
				getMessages().clear();
				getMessages().addAll((Collection)newValue);
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__ANNOTATIONS:
				getAnnotations().clear();
				getAnnotations().addAll((Collection)newValue);
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__INTERACTION:
				setInteraction((BVRInteraction)newValue);
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__PROPERTIES:
				getProperties().clear();
				getProperties().addAll((Collection)newValue);
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__DEFAULT_APPLICATION:
				setDefaultApplication((TPFDefaultApplication)newValue);
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__ACTUAL_GATES:
				getActualGates().clear();
				getActualGates().addAll((Collection)newValue);
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__REFERRED_BEHAVIOR:
				setReferredBehavior((BVRInteraction)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__ID:
				setId(ID_EDEFAULT);
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__DESCRIPTION:
				setDescription(DESCRIPTION_EDEFAULT);
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__LIFELINES:
				getLifelines().clear();
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__GENERAL_ORDERINGS:
				getGeneralOrderings().clear();
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__MESSAGES:
				getMessages().clear();
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__ANNOTATIONS:
				getAnnotations().clear();
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__INTERACTION:
				setInteraction((BVRInteraction)null);
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__PROPERTIES:
				getProperties().clear();
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__DEFAULT_APPLICATION:
				setDefaultApplication((TPFDefaultApplication)null);
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__ACTUAL_GATES:
				getActualGates().clear();
				return;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__REFERRED_BEHAVIOR:
				setReferredBehavior((BVRInteraction)null);
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__ID:
				return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals(id);
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__DESCRIPTION:
				return DESCRIPTION_EDEFAULT == null ? description != null : !DESCRIPTION_EDEFAULT.equals(description);
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__LIFELINES:
				return lifelines != null && !lifelines.isEmpty();
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__GENERAL_ORDERINGS:
				return generalOrderings != null && !generalOrderings.isEmpty();
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__MESSAGES:
				return messages != null && !messages.isEmpty();
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__ANNOTATIONS:
				return annotations != null && !annotations.isEmpty();
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__INTERACTION:
				return getInteraction() != null;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__PROPERTIES:
				return properties != null && !properties.isEmpty();
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__DEFAULT_APPLICATION:
				return defaultApplication != null;
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__ACTUAL_GATES:
				return actualGates != null && !actualGates.isEmpty();
			case Common_Behavior_FragmentsPackage.BVR_INTERACTION_OCCURRENCE__REFERRED_BEHAVIOR:
				return referredBehavior != null;
		}
		return eDynamicIsSet(eFeature);
	}

} //BVRInteractionOccurrenceImpl
