/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: TPFSUT.java,v 1.10 2005/03/28 21:51:31 jptoomey Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.common.testprofile;

import org.eclipse.hyades.models.common.configuration.CFGClass;
import org.eclipse.hyades.models.common.facades.behavioral.ISystemUnderTest;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>TPFSUT</b></em>'.
 * @extends ISystemUnderTest
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The SUT is the system under test. The SUT provides only a set of operations via publicly available interface(s) to enable blackbox testing.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFSUT#getLocation <em>Location</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFSUT#getResource <em>Resource</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.testprofile.TPFSUT#getTestSuite <em>Test Suite</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFSUT()
 * @model 
 * @generated
 */
public interface TPFSUT extends CFGClass, ISystemUnderTest{
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = "";

	/**
	 * Returns the value of the '<em><b>Location</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Location</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Location</em>' attribute.
	 * @see #setLocation(String)
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFSUT_Location()
	 * @model 
	 * @generated
	 */
	String getLocation();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.testprofile.TPFSUT#getLocation <em>Location</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Location</em>' attribute.
	 * @see #getLocation()
	 * @generated
	 */
	void setLocation(String value);

	/**
	 * Returns the value of the '<em><b>Resource</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Resource</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Resource</em>' attribute.
	 * @see #setResource(String)
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFSUT_Resource()
	 * @model 
	 * @generated
	 */
	String getResource();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.testprofile.TPFSUT#getResource <em>Resource</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Resource</em>' attribute.
	 * @see #getResource()
	 * @generated
	 */
	void setResource(String value);

	/**
	 * Returns the value of the '<em><b>Test Suite</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.common.testprofile.TPFTestSuite#getSUTs <em>SU Ts</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Test Suite</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Test Suite</em>' container reference.
	 * @see #setTestSuite(TPFTestSuite)
	 * @see org.eclipse.hyades.models.common.testprofile.Common_TestprofilePackage#getTPFSUT_TestSuite()
	 * @see org.eclipse.hyades.models.common.testprofile.TPFTestSuite#getSUTs
	 * @model opposite="SUTs"
	 * @generated
	 */
	TPFTestSuite getTestSuite();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.testprofile.TPFSUT#getTestSuite <em>Test Suite</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Test Suite</em>' container reference.
	 * @see #getTestSuite()
	 * @generated
	 */
	void setTestSuite(TPFTestSuite value);

} // TPFSUT
