/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: TRCEnvironmentVariable.java,v 1.18 2005/03/16 19:07:50 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.hierarchy;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>TRC Environment Variable</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A name-value pair to capture an environment variable. For example classpath
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.hierarchy.TRCEnvironmentVariable#getName <em>Name</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.hierarchy.TRCEnvironmentVariable#getValue <em>Value</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.hierarchy.TRCEnvironmentVariable#getProcessProxy <em>Process Proxy</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.hierarchy.HierarchyPackage#getTRCEnvironmentVariable()
 * @model 
 * @generated
 */
public interface TRCEnvironmentVariable extends EObject{
	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see org.eclipse.hyades.models.hierarchy.HierarchyPackage#getTRCEnvironmentVariable_Name()
	 * @model 
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.hierarchy.TRCEnvironmentVariable#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Value</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Value</em>' attribute.
	 * @see #setValue(String)
	 * @see org.eclipse.hyades.models.hierarchy.HierarchyPackage#getTRCEnvironmentVariable_Value()
	 * @model 
	 * @generated
	 */
	String getValue();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.hierarchy.TRCEnvironmentVariable#getValue <em>Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Value</em>' attribute.
	 * @see #getValue()
	 * @generated
	 */
	void setValue(String value);

	/**
	 * Returns the value of the '<em><b>Process Proxy</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.hierarchy.TRCProcessProxy#getEnvironmentVariables <em>Environment Variables</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Process Proxy</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Process Proxy</em>' container reference.
	 * @see #setProcessProxy(TRCProcessProxy)
	 * @see org.eclipse.hyades.models.hierarchy.HierarchyPackage#getTRCEnvironmentVariable_ProcessProxy()
	 * @see org.eclipse.hyades.models.hierarchy.TRCProcessProxy#getEnvironmentVariables
	 * @model opposite="environmentVariables" required="true"
	 * @generated
	 */
	TRCProcessProxy getProcessProxy();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.hierarchy.TRCEnvironmentVariable#getProcessProxy <em>Process Proxy</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Process Proxy</em>' container reference.
	 * @see #getProcessProxy()
	 * @generated
	 */
	void setProcessProxy(TRCProcessProxy value);

} // TRCEnvironmentVariable
