/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: ArithmeticOperators.java,v 1.5 2005/03/16 19:35:58 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.hierarchy.extensions;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import org.eclipse.emf.common.util.AbstractEnumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Arithmetic Operators</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see org.eclipse.hyades.models.hierarchy.extensions.ExtensionsPackage#getArithmeticOperators()
 * @model
 * @generated
 */
public final class ArithmeticOperators extends AbstractEnumerator {
	/**
	 * The '<em><b>ADD</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #ADD_LITERAL
	 * @model 
	 * @generated
	 * @ordered
	 */
	public static final int ADD = 0;

	/**
	 * The '<em><b>SUBSTRACT</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #SUBSTRACT_LITERAL
	 * @model 
	 * @generated
	 * @ordered
	 */
	public static final int SUBSTRACT = 1;

	/**
	 * The '<em><b>MULTIPLY</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MULTIPLY_LITERAL
	 * @model 
	 * @generated
	 * @ordered
	 */
	public static final int MULTIPLY = 2;

	/**
	 * The '<em><b>DIVIDE</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #DIVIDE_LITERAL
	 * @model 
	 * @generated
	 * @ordered
	 */
	public static final int DIVIDE = 3;

	/**
	 * The '<em><b>INTEGER DIVIDE</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #INTEGER_DIVIDE_LITERAL
	 * @model 
	 * @generated
	 * @ordered
	 */
	public static final int INTEGER_DIVIDE = 4;

	/**
	 * The '<em><b>MOD</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #MOD_LITERAL
	 * @model 
	 * @generated
	 * @ordered
	 */
	public static final int MOD = 5;

	/**
	 * The '<em><b>ADD</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>ADD</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #ADD
	 * @generated
	 * @ordered
	 */
	public static final ArithmeticOperators ADD_LITERAL = new ArithmeticOperators(ADD, "ADD");

	/**
	 * The '<em><b>SUBSTRACT</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>SUBSTRACT</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #SUBSTRACT
	 * @generated
	 * @ordered
	 */
	public static final ArithmeticOperators SUBSTRACT_LITERAL = new ArithmeticOperators(SUBSTRACT, "SUBSTRACT");

	/**
	 * The '<em><b>MULTIPLY</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>MULTIPLY</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MULTIPLY
	 * @generated
	 * @ordered
	 */
	public static final ArithmeticOperators MULTIPLY_LITERAL = new ArithmeticOperators(MULTIPLY, "MULTIPLY");

	/**
	 * The '<em><b>DIVIDE</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>DIVIDE</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #DIVIDE
	 * @generated
	 * @ordered
	 */
	public static final ArithmeticOperators DIVIDE_LITERAL = new ArithmeticOperators(DIVIDE, "DIVIDE");

	/**
	 * The '<em><b>INTEGER DIVIDE</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>INTEGER DIVIDE</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #INTEGER_DIVIDE
	 * @generated
	 * @ordered
	 */
	public static final ArithmeticOperators INTEGER_DIVIDE_LITERAL = new ArithmeticOperators(INTEGER_DIVIDE, "INTEGER_DIVIDE");

	/**
	 * The '<em><b>MOD</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>MOD</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #MOD
	 * @generated
	 * @ordered
	 */
	public static final ArithmeticOperators MOD_LITERAL = new ArithmeticOperators(MOD, "MOD");

	/**
	 * An array of all the '<em><b>Arithmetic Operators</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final ArithmeticOperators[] VALUES_ARRAY =
		new ArithmeticOperators[] {
			ADD_LITERAL,
			SUBSTRACT_LITERAL,
			MULTIPLY_LITERAL,
			DIVIDE_LITERAL,
			INTEGER_DIVIDE_LITERAL,
			MOD_LITERAL,
		};

	/**
	 * A public read-only list of all the '<em><b>Arithmetic Operators</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Arithmetic Operators</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static ArithmeticOperators get(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			ArithmeticOperators result = VALUES_ARRAY[i];
			if (result.toString().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Arithmetic Operators</b></em>' literal with the specified value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static ArithmeticOperators get(int value) {
		switch (value) {
			case ADD: return ADD_LITERAL;
			case SUBSTRACT: return SUBSTRACT_LITERAL;
			case MULTIPLY: return MULTIPLY_LITERAL;
			case DIVIDE: return DIVIDE_LITERAL;
			case INTEGER_DIVIDE: return INTEGER_DIVIDE_LITERAL;
			case MOD: return MOD_LITERAL;
		}
		return null;	
	}

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private ArithmeticOperators(int value, String name) {
		super(value, name);
	}

} //ArithmeticOperators
