/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: OrderByElement.java,v 1.15 2005/03/16 19:07:50 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.hierarchy.extensions;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Order By Element</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.hierarchy.extensions.OrderByElement#getOperator <em>Operator</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.hierarchy.extensions.OrderByElement#getOperand <em>Operand</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.hierarchy.extensions.OrderByElement#getSearchQuery <em>Search Query</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.hierarchy.extensions.ExtensionsPackage#getOrderByElement()
 * @model 
 * @generated
 */
public interface OrderByElement extends EObject{
	/**
	 * Returns the value of the '<em><b>Operator</b></em>' attribute.
	 * The literals are from the enumeration {@link org.eclipse.hyades.models.hierarchy.extensions.OrderByOperators}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Operator</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Operator</em>' attribute.
	 * @see org.eclipse.hyades.models.hierarchy.extensions.OrderByOperators
	 * @see #setOperator(OrderByOperators)
	 * @see org.eclipse.hyades.models.hierarchy.extensions.ExtensionsPackage#getOrderByElement_Operator()
	 * @model 
	 * @generated
	 */
	OrderByOperators getOperator();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.hierarchy.extensions.OrderByElement#getOperator <em>Operator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Operator</em>' attribute.
	 * @see org.eclipse.hyades.models.hierarchy.extensions.OrderByOperators
	 * @see #getOperator()
	 * @generated
	 */
	void setOperator(OrderByOperators value);

	/**
	 * Returns the value of the '<em><b>Operand</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Operand</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Operand</em>' containment reference.
	 * @see #setOperand(Operand)
	 * @see org.eclipse.hyades.models.hierarchy.extensions.ExtensionsPackage#getOrderByElement_Operand()
	 * @model containment="true"
	 * @generated
	 */
	Operand getOperand();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.hierarchy.extensions.OrderByElement#getOperand <em>Operand</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Operand</em>' containment reference.
	 * @see #getOperand()
	 * @generated
	 */
	void setOperand(Operand value);

	/**
	 * Returns the value of the '<em><b>Search Query</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.hyades.models.hierarchy.extensions.SimpleSearchQuery#getOrderByExpresions <em>Order By Expresions</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Search Query</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Search Query</em>' container reference.
	 * @see #setSearchQuery(SimpleSearchQuery)
	 * @see org.eclipse.hyades.models.hierarchy.extensions.ExtensionsPackage#getOrderByElement_SearchQuery()
	 * @see org.eclipse.hyades.models.hierarchy.extensions.SimpleSearchQuery#getOrderByExpresions
	 * @model opposite="orderByExpresions"
	 * @generated
	 */
	SimpleSearchQuery getSearchQuery();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.hierarchy.extensions.OrderByElement#getSearchQuery <em>Search Query</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Search Query</em>' container reference.
	 * @see #getSearchQuery()
	 * @generated
	 */
	void setSearchQuery(SimpleSearchQuery value);

} // OrderByElement
