/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: TString.java,v 1.5 2005/02/16 22:21:33 qiyanli Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.hyades.sdb.internal.util;

/**
 * This class provides static methods for some of the
 * very used IString operations
 */

public class TString
{
   // change all occurrences of oldPat to newPat
   public  static String change(String in, String oldPat, String newPat)
   {
	  if (oldPat.length() == 0)
		 return in;
	  if (oldPat.length() == 1 && newPat.length() == 1)
		 return in.replace(oldPat.charAt(0), newPat.charAt(0));

	  int lastIndex = 0;
	  int newIndex = 0;
	  StringBuffer newString = new StringBuffer();
	  for(;;)
	  {
		 newIndex = in.indexOf(oldPat, lastIndex);
		 if (newIndex != -1)
		 {
			newString.append(in.substring(lastIndex, newIndex) + newPat);
			lastIndex = newIndex + oldPat.length();
		 }
		 else
		 {
			newString.append(in.substring(lastIndex));
			break;
		 }
	  }
	  return newString.toString();
   }   
   
   public static String replaceTabsWithWhiteSpace(String str) {
    StringBuffer buffer = new StringBuffer(str.length());
    char[] chrs = str.toCharArray();
    int sz = chrs.length;
    boolean firstChrApp = false;
    for(int i=0; i<sz; i++) {
        switch(chrs[i]){	       
            case '\t':
            	if (firstChrApp) {
            		buffer.append(" ");
            	}
            	break;
            default: 
                buffer.append(chrs[i]);
            	firstChrApp = true;
        }
    }
    return buffer.toString();
   }   
}
